<?php
// Sécurité
define('OK',1);
// Configuration
include('config.php');
// Fonctions
include('fonctions.php');

// Vérification du token CSRF
if ( !isset($_REQUEST['csrf-token']) || isset($_SESSION['csrf-token']) && ( $_REQUEST['csrf-token'] != $_SESSION['csrf-token'] ) )
  exit('{"etat":"nok","message":"Accès non autorisé"}');

// Récupération de l'action
if ( !isset($_REQUEST['action']) || !in_array($action = $_REQUEST['action'],array('deconnexion', 'courriel', 'prefsperso', 'notes', 'ajout-notes', 'releve-notes', 'infos', 'ajout-info', 'reps', 'ajout-rep', 'docs', 'ajout-doc', 'colles', 'ajout-colle', 'cdt-elems', 'cdt-types', 'cdt-raccourcis', 'ajout-cdt-raccourci', 'pages', 'ajout-page', 'matieres', 'ajout-matiere', 'utilisateur', 'utilisateurs','ajout-utilisateurs', 'utilisateur-matiere', 'utilisateurs-matieres', 'groupes', 'ajout-groupe', 'planning', 'agenda-elems', 'deplcolle', 'agenda-types', 'ajout-agenda-types', 'prefsmatiere', 'prefsglobales')) )
  exit('{"etat":"nok","message":"Aucune action effectuée"}');

// Demande de déconnexion
if ( $action == 'deconnexion' )  {
  // Écriture de la déconnexion dans le fichier de log, sauf si la session a
  // été perdue parce qu'effacée du serveur
  if ( isset($_SESSION['login']) )
    logconnect(3,$_SESSION['login']);
  // Suppression du cookie et des données de session
  $_SESSION = array();
  setcookie(session_name(),'',time()-3600);
  setcookie('loginpermanent','',time()-3600);
  session_regenerate_id(true);
  // Recharge immédiate, donc besoin de $_SESSION['message']
  exit($_SESSION['message'] = '{"etat":"ok","message":"Déconnexion réussie"}');
}
// Si non autorisé, la session a dû expirer : il faut se reconnecter
if ( $autorisation == 0 )
  exit('{"etat":"login"}');

///////////////////////
// Envoi de courriel //
///////////////////////
if ( ( $action == 'courriel' ) && connexionlight() && $_SESSION['mailenvoi'] && isset($_REQUEST['id-copie']) && isset($_REQUEST['sujet']) && isset($_REQUEST['texte']) )  {

  // Vérification des données
  if ( !strlen($sujet = $_REQUEST['sujet']) )
    exit('{"etat":"nok","message":"Pas de sujet : courriel non envoyé"}');
  elseif ( !strlen($texte = $_REQUEST['texte']) )
    exit('{"etat":"nok","message":"Pas de texte : courriel non envoyé"}');
  // Vérification de l'adresse électronique
  $mysqli = connectsql();
  $resultat = $mysqli->query("SELECT mailexp, mail FROM utilisateurs WHERE id = ${_SESSION['id']}");
  $u = $resultat->fetch_assoc();
  $resultat->free();
  if ( !strlen($u['mailexp']) || !filter_var($u['mail'],FILTER_VALIDATE_EMAIL) )
    exit('{"etat":"nok","message":"Compte mal réglé&nbsp;: nom ou adresse d\'expédition manquants"}');
  // Récupération des destinataires, comptes valides uniquement
  $resultat = $mysqli->query("SELECT id, IF(LENGTH(nom),CONCAT(nom,' ',prenom),login) AS nom, mail
                              FROM utilisateurs WHERE mail > '' AND mdp > '0' AND id != ${_SESSION['id']} ORDER BY autorisation DESC, nom");
  $mysqli->close();
  while ( $r = $resultat->fetch_assoc() )
    $utilisateurs[$r['id']] = $r;
  $resultat->free();
  $dests = '';
  $ids = explode(',',$_REQUEST['id-copie']);
  foreach ( $ids as $i )
    if ( isset($utilisateurs[$i]) )  {
      $dests .= '=?UTF-8?B?'.base64_encode($utilisateurs[$i]['nom']).'?= <'.$utilisateurs[$i]['mail'].'>, ';
      unset($utilisateurs[$i]);
    }
  if ( !strlen($dests) )
    exit('{"etat":"nok","message":"Pas de destinataire valide : courriel non envoyé"}');
  // Fabrication du mail
  $dests = substr($dests,0,-2);
  $bcc = ( isset($_REQUEST['copie']) ) ? "${u['mailexp']} <${u['mail']}>, " : '';
  if ( strlen($_REQUEST['id-bcc']) )
    $ids = explode(',',$_REQUEST['id-bcc']);
    foreach ( $ids as $i )
      if ( isset($utilisateurs[$i]) )  {
        $bcc .= '=?UTF-8?B?'.base64_encode($utilisateurs[$i]['nom']).'?= <'.$utilisateurs[$i]['mail'].'>, ';
        unset($utilisateurs[$i]);
      }
  $bcc = ( strlen($bcc) ) ? 'Bcc: '.substr($bcc,0,-2) : '';
  mail($dests,'=?UTF-8?B?'.base64_encode($sujet).'?=',$texte,'From: =?UTF-8?B?'.base64_encode($u['mailexp']).'?= <nepasrepondre'.strstr($mailadmin,'@').">\r\nReply-To: =?UTF-8?B?".base64_encode($u['mailexp'])."?= <${u['mail']}>\r\nContent-type: text/plain; charset=UTF-8\r\n$bcc","-f${u['mail']}");
  // Message de confirmation d'envoi
  $n1 = substr_count($dests,'<');
  $n2 = substr_count($bcc,'<') - isset($_REQUEST['copie']);
  if ( $n2 )
    $message = 'La courriel a été envoyé à '.($n1+$n2).' destinataires (dont '.$n2.' en copie cachée).';
  else
    $message = ( $n1 > 1 ) ? "Le courriel a été envoyé à $n1 destinataires." : 'Le courriel a été envoyé à 1 destinataire.';
  exit($_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"$message\"}");

}

//////////////////////////////
// Préférences personnelles //
//////////////////////////////
elseif ( ( $action == 'prefsperso' ) && ( $autorisation > 1 ) )  {

  // Spécifications pour les manipulations de caractères sur 2 octets (accents)
  mb_internal_encoding('UTF-8');
  // Vérification obligatoire du mot de passe
  if ( !isset($_REQUEST['mdp']) )
    exit('{"etat":"nok","message":"Mot de passe incorrect"}');
  // L'adresse électronique sert dans les cas 1 et 4
  $mysqli = connectsql(true);
  $resultat = $mysqli->query("SELECT mdp, mail FROM utilisateurs WHERE id = ${_SESSION['id']}");
  $r = $resultat->fetch_assoc();
  $resultat->free();
  if ( ( sha1($mdp.$_REQUEST['mdp']) != $r['mdp'] ) && ( sha1($_REQUEST['mdp']) != $r['mdp'] ) )
    exit('{"etat":"nok","message":"Mot de passe incorrect"}');
  // Passage de la connexion light à normale si besoin
  if ( $_SESSION['light'] )  {
    $_SESSION['light'] = false;
    // Écriture de la connexion dans le fichier de log
    logconnect(5,$_SESSION['login']);
  }
  
  // Premier cadre de modifications de prefs.php : indentité
  if ( ( $_REQUEST['id'] == 1 ) && isset($_REQUEST['prenom']) && isset($_REQUEST['nom']) && isset($_REQUEST['mail1']) && isset($_REQUEST['mail2']) )  {
    $requete_mail = '';
    if ( !strlen($prenom = trim($_REQUEST['prenom'])) || !strlen($nom = trim($_REQUEST['nom'])) || !strlen($mail = mb_strtolower(trim($_REQUEST['mail1']))) )
      exit('{"etat":"nok","message":"Votre compte n\'a pas été modifié. Le prénom, le nom et l\'adresse électronique doivent rester non vides."}');
    if ( ( $mail != $r['mail'] ) && strlen($_REQUEST['mail2']) )  {
      if ( !filter_var($mail,FILTER_VALIDATE_EMAIL) )
        exit('{"etat":"nok","message":"Adresse électronique non valide"}');
      if ( $mail != mb_strtolower(trim($_REQUEST['mail2'])) )
        exit('{"etat":"nok","message":"Adresses électroniques différentes"}');
      // Vérification que l'adresse n'existe pas déjà
      $resultat = $mysqli->query("SELECT GROUP_CONCAT(mail) FROM utilisateurs WHERE id != ${_SESSION['id']} AND mail > ''");
      $r = $resultat->fetch_row();
      $resultat->free();
      if ( in_array($mail,explode(',',$r[0])) )
        exit('{"etat":"nok","message":"Adresse électronique non disponible"}');
      $requete_mail = ', mail = \''.$mysqli->real_escape_string($mail).'\'';
    }
    // Nettoyage des données envoyées
    $prenom = mb_convert_case(strip_tags($mysqli->real_escape_string($prenom)),MB_CASE_TITLE);
    $nom = mb_convert_case(strip_tags($mysqli->real_escape_string($nom)),MB_CASE_TITLE);
    if ( requete('utilisateurs',"UPDATE utilisateurs SET nom = '$nom', prenom = '$prenom'$requete_mail WHERE id = ${_SESSION['id']}",$mysqli) )
      exit('{"etat":"ok","message":"Vos préférences ont été modifiées."}');
    exit('{"etat":"nok","message":"Votre compte n\'a pas été modifié. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
  }
  
  // Deuxième cadre de modifications de prefs.php : mot de passe
  if ( ( $_REQUEST['id'] == 2 ) && isset($_REQUEST['mdp1']) && isset($_REQUEST['mdp2']) )  {
    if ( !strlen($mdp1 = $_REQUEST['mdp1']) || ( $mdp1 != $_REQUEST['mdp2'] ) )
      exit('{"etat":"nok","message":"Nouveau mot de passe et confirmation différents"}');
    // Token de connexion automatique
    if ( strlen($permconn = $_SESSION['permconn']) )
      for ( $i = 0; $i < 10; $i++ )
        $permconn .= '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ'[random_int(0,61)];
    if( requete('utilisateurs','UPDATE utilisateurs SET mdp = \''.sha1($mdp.$mdp1)."', permconn = '$permconn' WHERE id = ${_SESSION['id']}",$mysqli) )  {
      if ( strlen($permconn) )
        setcookie('loginpermanent',$permconn,time()+31536000);
      exit('{"etat":"ok","message":"Votre mot de passe a été modifié."}');
    }
    exit('{"etat":"nok","message":"Votre mot de passe n\'a pas été modifié. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
  }

  // Troisième cadre de modifications de prefs.php : connexion
  if ( ( $_REQUEST['id'] == 3 ) && isset($_REQUEST['login']) && isset($_REQUEST['timeout']) && ctype_digit($timeout = $_REQUEST['timeout']) )  {
    $requete_login = '';
    if ( !strlen($login = mb_strtolower(str_replace(' ','_',strip_tags(trim($_REQUEST['login']))))) )
      exit('{"etat":"nok","message":"Votre compte n\'a pas été modifié. L\'identifiant doit être non vide."}');
    if ( $login != $_SESSION['login'] )  {
      // Vérification que le login n'existe pas déjà
      $resultat = $mysqli->query("SELECT GROUP_CONCAT(login) FROM utilisateurs WHERE id != ${_SESSION['id']}");
      $r = $resultat->fetch_row();
      $resultat->free();
      if ( in_array($login,explode(',',$r[0])) )
        exit('{"etat":"nok","message":"Votre compte n\'a pas été modifié. L\'identifiant saisi est déjà utilisé."}');
      $requete_login = ', login = \''.$mysqli->real_escape_string($login).'\'';
    }
    // Token de connexion automatique
    if ( !strlen($permconn = $_SESSION['permconn']) && isset($_REQUEST['permconn']) )
      for ( $i = 0; $i < 10; $i++ )
        $permconn .= '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ'[random_int(0,61)];
    elseif ( !isset($_REQUEST['permconn']) )
      $permconn = '';
    $timeout = ( $timeout > 15 ) ? $timeout : 900;
    if ( requete('utilisateurs',"UPDATE utilisateurs SET timeout = $timeout$requete_login, permconn = '$permconn' WHERE id = ${_SESSION['id']}",$mysqli) )  {
      // Mise à jour des données de session et cookies
      $_SESSION['timeout'] = $timeout;
      $_SESSION['time'] = time()+$_SESSION['timeout'];
      $_SESSION['permconn'] = $permconn;
      setcookie('loginpermanent',$permconn,( strlen($permconn) ) ? time()+31536000 : time()-3600);
      if ( strlen($requete_login) )
        $_SESSION['login'] = $login;
      exit('{"etat":"ok","message":"Vos préférences de connexion ont été modifiées."}');
    }
    exit('{"etat":"nok","message":"Votre compte n\'a pas été modifié. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
  }

  // Quatrième cadre de modifications de prefs.php : envoi de courriel
  if ( ( $_REQUEST['id'] == 4 ) && isset($_REQUEST['mailexp']) )  {
    // Compte élève : modification possible seulement si envoi de courriel déjà possible
    if ( $autorisation == 2 )  {
      if ( $_SESSION['mailenvoi'] == 0 )
        exit('{"etat":"nok","message":"Ce réglage n\'est pas autorisé."}');
      if ( !strlen($mailexp = strip_tags(trim($_REQUEST['mailexp']))) )
        exit('{"etat":"nok","message":"Votre compte n\'a pas été modifié. Le nom d\'expéditeur doit être non vide."}');
      if( requete('utilisateurs','UPDATE utilisateurs SET mailexp = \''.$mysqli->real_escape_string($mailexp).'\', mailcopie = '.intval(isset($_REQUEST['mailcopie']))." WHERE id = ${_SESSION['id']}",$mysqli) )
        exit('{"etat":"ok","message":"Vos préférences d\'envoi de mail ont été modifiées."}');
      exit('{"etat":"nok","message":"Votre compte n\'a pas été modifié. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}' );
    }
    // Autres types de comptes
    // Interdiction de vider mailexp si on souhaite garder l'envoi possible
    $mailexp = strip_tags(trim($_REQUEST['mailexp']));
    if ( ( $mailenvoi = intval(isset($_REQUEST['mailenvoi'])) ) && !strlen($mailexp) )
      exit('{"etat":"nok","message":"Votre compte n\'a pas été modifié. Le nom d\'expéditeur doit être non vide."}');
    // Interdiction d'envoyer si l'adresse électronique est vide
    if ( $mailenvoi && !strlen($r['mail']) )
      exit('{"etat":"nok","message":"Votre compte n\'a pas été modifié. Il est impossible d\'envoyer des courriels sans adresse électronique."}');
    if ( requete('utilisateurs','UPDATE utilisateurs SET mailexp = \''.$mysqli->real_escape_string($mailexp)."', mailenvoi = $mailenvoi, mailcopie = ".intval(isset($_REQUEST['mailcopie'])).', mailliste = '.intval(isset($_REQUEST['mailliste']))." WHERE id = ${_SESSION['id']}",$mysqli) )  {
      $_SESSION['mailenvoi'] = $mailenvoi;
      exit('{"etat":"ok","message":"Vos préférences d\'envoi de mail ont été modifiées."}');
    }
    exit('{"etat":"nok","message":"Votre compte n\'a pas été modifié. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
  }

}

///////////////////////////////////////////////////////////
// Modification de notes (accès colleurs et professeurs) //
///////////////////////////////////////////////////////////
elseif ( ( $action == 'notes' ) && ( ( $autorisation == 3 ) || ( $autorisation == 5 ) ) && isset($_REQUEST['id']) && ctype_digit($id = $_REQUEST['id']) )  {

  // Connexion normale obligatoire
  connexionlight();
  $mysqli = connectsql(true);
  // Spécifications pour les manipulations de caractères sur 2 octets (accents)
  mb_internal_encoding('UTF-8');

  // Vérification que l'identifiant est valide
  $resultat = $mysqli->query("SELECT matiere, DATE_FORMAT(jour,'%w%Y%m%e') AS date, DATE_FORMAT(jour,'%Y-%m-%d') AS jour,
                              TIME_FORMAT(heure,'%k:%i') AS heure, duree, releve>0 AS releve, description 
                              FROM heurescolles WHERE id = $id AND colleur = ${_SESSION['id']}");
  if ( !$resultat->num_rows )
    exit('{"etat":"nok","message":"Identifiant non valide"}');
  $r = $resultat->fetch_assoc();
  $resultat->free();
  $matiere = $r['matiere'];
  
  // Suppression
  if ( isset($_REQUEST['supprime']) )  {
    if ( $r['releve'] > 0 )
      exit('{"etat":"nok","message":"La colle n\'a pas été supprimée car elle a déjà été relevée."}');
    // Heures en séances de TD (pas de notes associées)
    if ( strlen($r['description']) )
      exit( requete('heurescolles',"DELETE FROM heurescolles WHERE id = $id",$mysqli)
          ? '{"etat":"ok","message":"La séance du <em>'.format_date($r['date']).'</em> a été supprimée."}'
          : '{"etat":"nok","message":"La séance du <em>'.format_date($r['date']).'</em> n\'a pas été supprimée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
    // Colle avec notes
    $resultat = $mysqli->query("SELECT * FROM notes WHERE heure = $id");
    $n = $resultat->num_rows;
    $resultat->free();
    exit( requete('notes',"DELETE FROM notes WHERE heure = $id",$mysqli)
       && requete('heurescolles',"DELETE FROM heurescolles WHERE id = $id",$mysqli)
       && $mysqli->query('UPDATE matieres SET notes = IF((SELECT id FROM notes WHERE matiere = matieres.id LIMIT 1),1,0)')
          ? "{\"etat\":\"ok\",\"message\":\"Les $n notes du <em>".format_date($r['date']).'</em> ont été supprimées."}'
          : "{\"etat\":\"nok\",\"message\":\"Les $n notes du <em>".format_date($r['date']).'</em> n\'ont pas été supprimées. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
  }
  
  // Modification
  if ( isset($_REQUEST['jour']) && isset($_REQUEST['heure']) )  {
    
    // Heures en séances de TD (pas de notes associées)
    if ( strlen($r['description']) )  {
      $requete = array();
      // Validation du jour
      if ( $r['jour'] != ( $jour = preg_filter('/(\d{2})\/(\d{2})\/(\d{4})/','$3-$2-$1',$_REQUEST['jour']) ) )  {
        // Vérification que le jour est bien dans l'année
        $resultat = $mysqli->query("SELECT id FROM semaines WHERE debut <= '$jour' AND debut >= SUBDATE('$jour',7) ORDER BY debut DESC LIMIT 1");
        if ( !$resultat->num_rows )
          exit('{"etat":"nok","message":"Le jour choisi ne se trouve pas dans l\'année scolaire. S\'il s\'agit d\'une erreur, il faut peut-être contacter l\'administrateur."}');
        $resultat->free();
        $requete[] = "jour = '$jour'";
      }
      // Validation de l'heure
      if ( ( $r['heure'] != ( $heure = preg_filter('/(\d{1,2})h(\d{2})/','$1:$2',$_REQUEST['heure']) ) ) && strlen($heure) )
        $requete[] = "heure = '$heure'";
      // Validation de la durée (séance non relevée uniquement)
      if ( ( $r['releve'] == 0 ) && isset($_REQUEST['duree']) && ( $r['duree'] != ( $duree = call_user_func_array(function ($h,$m) { return intval($h)*60+intval($m); }, array_pad(explode('h',$_REQUEST['duree']),2,0)) ) && ( $duree > 0 ) ) )
        $requete[] = "duree = '$duree'";
      // Validation de la description
      if ( ( $r['description'] != ( $description = trim(htmlspecialchars($_REQUEST['description'])) ) ) && strlen($description) )
        $requete[] = 'description = \''.$mysqli->real_escape_string(mb_strtoupper(mb_substr($description,0,1)).mb_substr($description,1)).'\'';
      // Écriture dans la table heurescolles
      if ( $requete )  {
        if ( requete('heurescolles','UPDATE heurescolles SET '.implode(', ',$requete)." WHERE id = $id",$mysqli) ) 
          exit($_SESSION['message'] = '{"etat":"ok","message":"La séance du <em>'.format_date($r['date']).'</em> a été modifiée."}');
        exit('{"etat":"nok","message":"La séance n\'a pas été modifiée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
      }
      else
        exit('{"etat":"nok","message":"La séance du <em>'.format_date($r['date']).'</em> n\'a pas été modifiée. Aucune modification demandée."}');
    }

    // Récupération des notes déjà existantes cette semaine
    $resultat = $mysqli->query("SELECT semaine, GROUP_CONCAT(eleve) AS dejanotes,
                                GROUP_CONCAT(IF(heure=$id,eleve,NULL)) AS eleves,
                                GROUP_CONCAT(IF(heure=$id,CONCAT(note,'-',id),NULL) SEPARATOR '|' ) AS notes
                                FROM notes WHERE semaine = (SELECT semaine FROM notes WHERE heure = $id LIMIT 1) AND matiere = $matiere");
    $s = $resultat->fetch_assoc();
    $resultat->free();
    $semaine = $s['semaine'];
    $notesperso = array_combine(explode(',',$s['eleves']),explode('|',$s['notes']));
    $dejanotes = $s['dejanotes'];
    $notes = array('0','1','2','3','4','5','6','7','8','9','10','11','12','13','14','15','16','17','18','19','20','0,5','1,5','2,5','3,5','4,5','5,5','6,5','7,5','8,5','9,5','10,5','11,5','12,5','13,5','14,5','15,5','16,5','17,5','18,5','19,5','abs','nn');
    $requete_generale = $requete_notes = $message = array();
    $etat = 'ok';
    
    // Validation du jour
    if ( $r['jour'] != ( $jour = preg_filter('/(\d{2})\/(\d{2})\/(\d{4})/','$3-$2-$1',$_REQUEST['jour']) ) )  {
      // Vérification que le jour est bien dans la semaine prévue
      $resultat = $mysqli->query("SELECT DATEDIFF('$jour',debut) FROM semaines WHERE id = $semaine OR id = $semaine+1");
      $s = $resultat->fetch_row();
      if ( ( $s[0] >= 0 ) && ( ( $resultat->num_rows == 1 ) && ( $s[0] < 7 ) || ( $s = $resultat->fetch_row() ) && ( $s[0] < 0 ) ) )
        $requete_generale[] = "jour = '$jour'";
      $resultat->free();
    }
    // Validation de l'heure
    if ( ( $r['heure'] != ( $heure = preg_filter('/(\d{1,2})h(\d{2})/','$1:$2',$_REQUEST['heure']) ) ) && strlen($heure) )
      $requete_generale[] = "heure = '$heure'";
    
    // Si colle déjà relevée : modification des notes déjà mises uniquement
    if ( $r['releve'] == 1 )  {
      foreach ( $notesperso as $eleve => $note )
        if ( isset($_REQUEST["e$eleve"]) && in_array($newnote = $_REQUEST["e$eleve"], $notes, true) && ( $newnote != strstr($note,'-',true) ) )
          $requete_notes[] = "UPDATE notes SET note = '$newnote' WHERE id = ". substr(strstr($note,'-'),1);
    }
    // Si colle non déjà relevée : modification de la durée possible, et
    // modification/ajout/suppression de notes possible 
    else  {
      // Validation de la durée
      if ( isset($_REQUEST['duree']) && ( $r['duree'] != ( $duree = call_user_func_array(function ($h,$m) { return intval($h)*60+intval($m); }, array_pad(explode('h',$_REQUEST['duree']),2,0))) ) && ( $duree > 0 ) )
        $requete_generale[] = "duree = '$duree'";
      // Validation des notes déjà mises à modifier/supprimer
      foreach ( $notesperso as $eleve => $note )  {
        if ( !isset($_REQUEST["e$eleve"]) || !in_array($newnote = $_REQUEST["e$eleve"], $notes, true) )
          $requete_notes[] = 'DELETE FROM notes WHERE id = '. substr(strstr($note,'-'),1);
        elseif ( $newnote != strstr($note,'-',true) )
          $requete_notes[] = "UPDATE notes SET note = '$newnote' WHERE id = ". substr(strstr($note,'-'),1);
      }
      // Récupération des élèves associés à la matière
      $resultat = $mysqli->query("SELECT GROUP_CONCAT(id) FROM utilisateurs WHERE autorisation = 2 AND FIND_IN_SET($matiere,matieres)");
      $s = $resultat->fetch_row();
      $resultat->free();
      // Insertion pour les élèves non déjà notés
      $elevesdispos = array_diff(explode(',',$s[0]),explode(',',$dejanotes));
      foreach ( $elevesdispos as $eleve ){
        if ( isset($_REQUEST["e$eleve"]) && in_array($note = $_REQUEST["e$eleve"], $notes, true) )
          $requete_notes[] = "INSERT INTO notes (semaine,heure,eleve,colleur,matiere,note) VALUES ($semaine,$id,$eleve,${_SESSION['id']},$matiere,'$note')";
        }
    }
    
    // Exécution
    if ( $requete_generale )  {
      if ( requete('heurescolles','UPDATE heurescolles SET '.implode(', ',$requete_generale
      )." WHERE id = $id",$mysqli) ) 
        $message[] = 'La colle du <em>'.format_date($r['date']).'</em> a été modifiée.';
      else  {
        $message[] = 'La colle du <em>'.format_date($r['date']).'</em> n\'a pas été modifiée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'».';
        $etat = 'nok';
      }
    }
    if ( ( $etat == 'ok' ) && $requete_notes )  {
      $nb_ok = 0;
      foreach ( $requete_notes as $requete )  {
        if ( requete('notes',$requete,$mysqli) ) 
          $nb_ok += 1;
        else  {
          $message[] = 'Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'».';
          $etat = 'nok';
        }
      }
      $message[] = ( ($nb_ok == 1) ? 'Une note a été modifiée/supprimée/ajoutée.' : "$nb_ok notes ont été modifiées/supprimées/ajoutées.");
    }
      
    // Reconstruction du message
    if ( !$message )
      exit('{"etat":"nok","message":"La colle du <em>'.format_date($r['date']).'</em> n\'a pas été modifiée. Aucune modification demandée."}');
    if ( $etat == 'nok')
      exit('{"etat":"nok","message":"'.implode('<br>',$message).'"}');
    // Mise à jour des champs 'notes' dans la table 'matieres' (pour le menu)
    $mysqli->query("UPDATE matieres SET notes = IF((SELECT id FROM notes WHERE matiere = $matiere LIMIT 1),1,0) WHERE id = $matiere");
    exit($_SESSION['message'] = '{"etat":"ok","message":"'.implode('<br>',$message).'"}');
  }
}

//////////////////////////////////////////////////////////////
// Ajout de notes de colles (accès colleurs et professeurs) //
//////////////////////////////////////////////////////////////
elseif ( ( $action == 'ajout-notes' ) && ( ( $autorisation == 3 ) || ( $autorisation == 5 ) ) && isset($_REQUEST['matiere']) && in_array($matiere = intval($_REQUEST['matiere']),explode(',',$_SESSION['matieres'])) && isset($_REQUEST['jour']) && strlen($jour = preg_filter('/(\d{2})\/(\d{2})\/(\d{4})/','$3-$2-$1',$_REQUEST['jour'])) && isset($_REQUEST['heure']) && isset($_REQUEST['duree']) )  {

  // Connexion normale obligatoire
  connexionlight();
  $mysqli = connectsql(true);
  // Spécifications pour les manipulations de caractères sur 2 octets (accents)
  mb_internal_encoding('UTF-8');

  // Vérification de l'heure (non obligatoire : chaîne vide éventuellement)
  $heure = preg_filter('/(\d{1,2})h(\d{2})/','$1:$2',$_REQUEST['heure']);
  // Vérification de la durée
  if ( ( $duree = call_user_func_array(function ($h,$m) { return intval($h)*60+intval($m); }, array_pad(explode('h',$_REQUEST['duree']),2,0)) ) == 0 )
    exit('{"etat":"nok","message":"La durée saisie ne peut pas être nulle."}');

  // Heures en séances de TD (pas de notes associées)
  if ( isset($_REQUEST['td']) && isset($_REQUEST['description']) )  {
    // Vérification que le jour est bien dans l'année
    $resultat = $mysqli->query("SELECT id FROM semaines WHERE debut <= '$jour' AND debut >= SUBDATE('$jour',7) ORDER BY debut DESC LIMIT 1");
    if ( !$resultat->num_rows )
      exit('{"etat":"nok","message":"Le jour choisi ne se trouve pas dans l\'année scolaire. S\'il s\'agit d\'une erreur, il faut peut-être contacter l\'administrateur."}');
    $resultat->free();
    // Vérification de la description
    if ( !strlen($description = trim(htmlspecialchars($_REQUEST['description']))) )
      exit('{"etat":"nok","message":"Pour les séances de TD sans note, la description de la séance doit obligatoirement être non vide."}');
    // Écriture dans la table heurescolles
    if ( requete('heurescolles',"INSERT INTO heurescolles SET colleur = ${_SESSION['id']}, matiere = $matiere, jour = '$jour', heure = '$heure', duree = '$duree', description = '".$mysqli->real_escape_string(mb_strtoupper(mb_substr($description,0,1)).mb_substr($description,1)).'\'',$mysqli) )
      exit($_SESSION['message'] = '{"etat":"ok","message":"La séance a été ajoutée."}');
    exit('{"etat":"nok","message":"La séance n\'a pas été ajoutée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
  }
  
  // Vérification de l'identifiant de la semaine
  if ( !isset($_REQUEST['sid']) || !ctype_digit($sid = $_REQUEST['sid']) )
    exit('{"etat":"nok","message":"Semaine non valide"}');
  $resultat = $mysqli->query("SELECT (SELECT GROUP_CONCAT(eleve) FROM notes WHERE semaine = semaines.id AND matiere = $matiere) FROM semaines WHERE id = $sid AND colle");
  if ( !$resultat->num_rows )
    exit('{"etat":"nok","message":"Semaine non valide"}');
  $r = $resultat->fetch_row();
  $resultat->free();
  $dejanotes = $r[0];
  
  // Vérification que le jour est bien dans la semaine prévue
  $resultat = $mysqli->query("SELECT DATEDIFF('$jour',debut) FROM semaines WHERE id = $sid OR id = $sid+1");
  $r = $resultat->fetch_row();
  if ( ( $r[0] < 0 ) || ( ( $resultat->num_rows == 1 ) && ( $r[0] >= 7 ) || ( $r = $resultat->fetch_row() ) && ( $r[0] >= 0 ) ) )
    exit('{"etat":"nok","message":"La date saisie ne se trouve pas dans la semaine choisie."}');
  $resultat->free();

  // Écriture de l'heure dans la table heurescolles
  if ( !requete('heurescolles',"INSERT INTO heurescolles SET colleur = ${_SESSION['id']}, matiere = $matiere, jour = '$jour', heure = '$heure', duree = '$duree', description = ''",$mysqli) )
    exit('{"etat":"nok","message":"La colle n\'a pas été ajoutée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
  $heure = $mysqli->insert_id;
  
  // Récupération des élèves associés à la matière
  $resultat = $mysqli->query("SELECT GROUP_CONCAT(id) FROM utilisateurs WHERE autorisation = 2 AND FIND_IN_SET($matiere,matieres)");
  $r = $resultat->fetch_row();
  $resultat->free();
  $elevesdispos = array_diff(explode(',',$r[0]),explode(',',$dejanotes));
  $notes = array('0','1','2','3','4','5','6','7','8','9','10','11','12','13','14','15','16','17','18','19','20','0,5','1,5','2,5','3,5','4,5','5,5','6,5','7,5','8,5','9,5','10,5','11,5','12,5','13,5','14,5','15,5','16,5','17,5','18,5','19,5','abs','nn');

  // Insertion pour les élèves non déjà notés
  $requete = array();
  foreach ( $elevesdispos as $eleve )
    if ( isset($_REQUEST["e$eleve"]) && in_array($note = $_REQUEST["e$eleve"], $notes, true) )
      $requete[] = "($sid,$heure,$eleve,${_SESSION['id']},$matiere,'$note')";
  if ( !$requete )  {
    requete('heurescolles',"DELETE FROM heurescolles WHERE id=$heure",$mysqli);
    exit('{"etat":"nok","message":"La colle n\'a pas été ajoutée, car aucune note valable n\'a été saisie."}');
  }
  // Écriture des notes
  if ( requete('notes','INSERT INTO notes (semaine,heure,eleve,colleur,matiere,note) VALUES '.implode(',',$requete),$mysqli) && $mysqli->query("UPDATE matieres SET notes = IF((SELECT id FROM notes WHERE matiere = $matiere LIMIT 1),1,0) WHERE id = $matiere") )
    exit($_SESSION['message'] = '{"etat":"ok","message":"'.count($requete).' notes ont été ajoutées."}');
  exit('{"etat":"nok","message":"Toutes les notes saisies n\'ont pas été ajoutées. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
}

///////////////////////////////////////////////////////
// Relève des notes de colles (accès administration) //
///////////////////////////////////////////////////////
elseif ( ( $action == 'releve-notes' ) && ( $autorisation == 4 ) )  {

  // Connexion normale obligatoire
  connexionlight();
  $mysqli = connectsql(true);

  // Vérification qu'il y a des colles à relever
  $resultat = $mysqli->query('SELECT * FROM heurescolles WHERE releve=0');
  if ( !$resultat->num_rows )
    exit('{"etat":"nok","message":"Il n\'a pas d\'heure de colle à relever aujourd\'hui."}');
  if ( requete('heurescolles','UPDATE heurescolles SET releve=CURDATE() WHERE releve=0', $mysqli) )
    exit($_SESSION['message'] = '{"etat":"ok","message":"De nouvelles heures de colles ont été relevées et apparaissent dans le tableau général."}');
  exit('{"etat":"nok","message":"L\'information n\'a pas été modifiée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
}

/////////////////////////////////////////////////
// À partir d'ici, accès professeur uniquement //
/////////////////////////////////////////////////
if ( ( $autorisation < 5 ) )
  exit( '{"etat":"nok","message":"Aucune action effectuée"}' );
// Connexion normale obligatoire
connexionlight();
$mysqli = connectsql(true);
// Spécifications pour les manipulations de caractères sur 2 octets (accents)
mb_internal_encoding('UTF-8');

///////////////////////////////////
// Modification des informations //
///////////////////////////////////
if ( $action == 'infos' && isset($_REQUEST['id']) && ctype_digit($id = $_REQUEST['id']) )  {
  
  // Vérification que l'identifiant est valide
  $resultat = $mysqli->query("SELECT i.ordre, i.titre, cache, texte, page, cle, i.protection, p.mat, ( SELECT COUNT(*) FROM infos WHERE page = i.page ) AS max FROM infos AS i LEFT JOIN pages AS p ON i.page = p.id WHERE i.id = $id AND FIND_IN_SET(p.mat,'${_SESSION['matieres']}')");
  if ( !$resultat->num_rows )
    exit('{"etat":"nok","message":"Identifiant de page non valide"}');
  $r = $resultat->fetch_assoc();
  $resultat->free();

  // Traitement d'une modification
  if ( isset($_REQUEST['champ']) && in_array($champ = $_REQUEST['champ'],array('titre','texte')) )  {
    $valeur = trim($mysqli->real_escape_string($_REQUEST['val']));
    if ( ( $champ == 'texte' ) && ( !strlen($valeur) ) )
      exit('{"etat":"nok","message":"L\'information n\'a pas été modifiée. Le texte doit être non vide."}');
    elseif ( requete('infos',"UPDATE infos SET $champ = '$valeur' WHERE id = $id",$mysqli) )  {
      recent($mysqli,1,$id,$r['mat'],( $champ == 'titre' ) ? array('titre'=>( $valeur ?: 'Information')) : array('texte'=>$valeur));
      exit('{"etat":"ok","message":"L\'information a été modifiée."}');
    }
    exit('{"etat":"nok","message":"L\'information n\'a pas été modifiée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
  }

  // Changement de protection
  if ( isset($_REQUEST['champ']) && ( $_REQUEST['champ'] == 'protection' ) && ctype_digit($valeur = $_REQUEST['val']) )  {
    if ( $r['protection'] == $valeur )
      exit('{"etat":"nok","message":"La protection de l\'information n\'a pas été modifiée car elle est inchangée."}');
    if ( requete('infos',"UPDATE infos SET protection = $valeur WHERE id = $id",$mysqli) )  {
      recent($mysqli,1,$id,$r['mat'],array('protection'=>$valeur));
      exit('{"etat":"ok","message":"L\'information a été modifiée."}');
    }
    exit('{"etat":"nok","message":"L\'information n\'a pas été modifiée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
  }

  // Déplacement vers le haut
  if ( isset($_REQUEST['monte']) && ( $r['ordre'] > 1 ) )
    exit( requete('infos',"UPDATE infos SET ordre = (2*${r['ordre']}-1-ordre) WHERE ( ordre = ${r['ordre']} OR ordre = (${r['ordre']}-1) ) AND page = ${r['page']}",$mysqli) && $mysqli->query('ALTER TABLE infos ORDER BY page,ordre')
      ? '{"etat":"ok","message":"L\'information a été déplacée."}'
      : '{"etat":"nok","message":"L\'information n\'a pas été déplacée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');

  // Déplacement vers le bas
  if ( isset($_REQUEST['descend']) && ( $r['ordre'] < $r['max'] ) )
    exit( requete('infos',"UPDATE infos SET ordre = (2*${r['ordre']}+1-ordre) WHERE ( ordre = ${r['ordre']} OR ordre = (${r['ordre']}+1) ) AND page = ${r['page']}",$mysqli) && $mysqli->query('ALTER TABLE infos ORDER BY page,ordre')
      ? '{"etat":"ok","message":"L\'information a été déplacée."}'
      : '{"etat":"nok","message":"L\'information n\'a pas été déplacée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');

  // Positionnement "montré" (apparaît sur la partie publique)
  if ( isset($_REQUEST['montre']) )  {
    if ( requete('infos',"UPDATE infos SET cache = 0 WHERE id = $id",$mysqli) )  {
      recent($mysqli,1,$id,$r['mat'],array('titre'=>( strlen($r['titre']) ? $mysqli->real_escape_string($r['titre']) : 'Information'), 'lien'=>".?${r['cle']}", 'texte'=>$mysqli->real_escape_string($r['texte']), 'matiere'=>$r['mat'], 'protection'=>$r['protection']));
      exit('{"etat":"ok","message":"L\'information apparaît désormais sur la partie publique."}');
    }
    exit('{"etat":"nok","message":"L\'information n\'a pas été diffusée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
  }

  // Positionnement "caché" (n'apparaît pas sur la partie publique)
  if ( isset($_REQUEST['cache']) )  {
    if ( requete('infos',"UPDATE infos SET cache = 1 WHERE id = $id",$mysqli) )  {
      recent($mysqli,1,$id,$r['mat']);
      exit('{"etat":"ok","message":"L\'information n\'apparaît plus sur la partie publique mais est toujours disponible ici pour modification ou diffusion."}');
    }
    exit('{"etat":"nok","message":"L\'information n\'a pas été cachée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
  }

  // Suppression
  if ( isset($_REQUEST['supprime']) )  {
    if ( requete('infos',"DELETE FROM infos WHERE id = $id",$mysqli) 
      && requete('infos',"UPDATE infos SET ordre = (ordre-1) WHERE ordre > ${r['ordre']} AND page = ${r['page']}",$mysqli) )  {
      recent($mysqli,1,$id,$r['mat']);
      exit('{"etat":"ok","message":"Suppression réalisée"}');
    }
    exit('{"etat":"nok","message":"L\'information n\'a pas été supprimée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
  }
}

/////////////////////////////
// Ajout d'une information //
/////////////////////////////
elseif ( ( $action == 'ajout-info' ) && isset($_REQUEST['titre']) && isset($_REQUEST['texte']) && isset($_REQUEST['protection']) && isset($_REQUEST['page']) && ctype_digit($page = $_REQUEST['page']) )  {
  // Vérification de l'identifiant de la page
  $resultat = $mysqli->query("SELECT cle,mat FROM pages WHERE id = $page AND FIND_IN_SET(mat,'${_SESSION['matieres']}')");
  if ( !$resultat->num_rows )
    exit('{"etat":"nok","message":"Identifiant de page non valide"}');
  $r = $resultat->fetch_assoc();
  $resultat->free();
  // Génération de la valeur de protection
  if ( !count($val = array_filter($_REQUEST['protection'],function($id) { return ctype_digit($id); })) )
    exit('{"etat":"nok","message":"L\'information n\'a pas été ajoutée. La protection d\'accès est incorrecte."}');
  if ( ( $val[0] == 0 ) || ( $val[0] == 32 ) )
    $protection = $val[0];
  else  {
    $protection = 32;
    foreach (array_slice($val,1) as $v) 
      $protection = $protection-2**($v-1);
  }
  // Autres données
  $titre = trim($mysqli->real_escape_string($_REQUEST['titre']));
  $texte = trim($mysqli->real_escape_string($_REQUEST['texte']));
  $cache = intval(isset($_REQUEST['cache']));
  if ( !strlen($texte) )
    exit('{"etat":"nok","message":"L\'information n\'a pas été ajoutée. Le texte doit être non vide."}');
  // Écriture
  if ( requete('infos',"UPDATE infos SET ordre = (ordre+1) WHERE page = $page",$mysqli)
    && requete('infos',"INSERT INTO infos SET ordre = 1, page = $page, texte = '$texte', titre = '$titre', cache = $cache, protection = $protection",$mysqli) )  {
    if ( !$cache )
      recent($mysqli,1,$mysqli->insert_id,$r['mat'],array('titre'=>( $titre ?: 'Information'), 'lien'=>".?${r['cle']}", 'texte'=>$texte, 'matiere'=>$r['mat'], 'protection'=>$protection));
    $mysqli->query('ALTER TABLE infos ORDER BY page,ordre');
    exit($_SESSION['message'] = '{"etat":"ok","message":"L\'information a été ajoutée."}');
  }
  exit('{"etat":"nok","message":"L\'information n\'a pas été ajoutée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
}

//////////////////////////////////
// Modification des répertoires //
//////////////////////////////////
elseif ( ( $action == 'reps' ) && isset($_REQUEST['id']) && ctype_digit($id = $_REQUEST['id']) )  {
  
  // Vérification que l'identifiant est valide
  $resultat = $mysqli->query("SELECT parent, nom, menu, protection, matiere FROM reps WHERE id = $id AND FIND_IN_SET(matiere,'${_SESSION['matieres']}')");
  if ( !$resultat->num_rows )
    exit('{"etat":"nok","message":"Identifiant de répertoire non valide"}');
  $r = $resultat->fetch_assoc();
  $resultat->free();
  
  // Traitement d'une modification unique (nom)
  if ( isset($_REQUEST['champ']) && ( $_REQUEST['champ'] == 'nom' ) )  {
    if ( !$r['parent'] )
      exit('{"etat":"nok","message":"Le nom des répertoires racine des matières ne sont pas modifiables."}');
    if ( !strlen($valeur = trim($mysqli->real_escape_string($_REQUEST['val'])) ) )
      exit("{\"etat\":\"nok\",\"message\":\"Le répertoire <em>${r['nom']}</em> n'a pas été modifié. Le nom doit être non vide.\"}");
    if ( !requete('reps',"UPDATE reps SET nom = '$valeur' WHERE id = $id",$mysqli) )
      exit("{\"etat\":\"nok\",\"message\":\"Le nom du répertoire <em>${r['nom']}</em> n'a pas été modifié. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
    exit("{\"etat\":\"ok\",\"message\":\"Le nom du répertoire <em>${r['nom']}</em> a été modifié.}");
  }
    
  // Traitement d'une modification globale
  if ( isset($_REQUEST['protection']) )  {
    $requete = $message = array();
    $etat = 'ok';
    // Modification du nom, de l'affichage dans le menu uniquement si pas à la racine
    if ( $r['parent'] && isset($_REQUEST['nom']) )  {
      if ( strlen( $nom = trim($mysqli->real_escape_string($_REQUEST['nom'])) ) && ( $nom != $r['nom'] ) )
        $requete[] = "nom = '$nom'";
      $menu = intval(isset($_REQUEST['menu']));
      if ( $menu != $r['menu'] )
        $requete[] = "menu = $menu";
    }
    // Génération de la valeur de protection
    if ( count($val = array_filter($_REQUEST['protection'],function($id) { return ctype_digit($id); })) )  {
      if ( ( $val[0] == 0 ) || ( $val[0] == 32 ) )
        $protection = $val[0];
      else  {
        $protection = 32;
        foreach (array_slice($val,1) as $v) 
          $protection = $protection-2**($v-1);
      }
      if ( $protection != $r['protection'] )
        $requete[] = "protection = $protection";
    }
    if ( $requete )  {
      if ( requete('reps','UPDATE reps SET '.implode(', ',$requete)." WHERE id = $id",$mysqli) ) 
        $message[] = "Le répertoire <em>${r['nom']}</em> a été modifié.";
      else  {
        $message[] = "Le répertoire <em>${r['nom']}</em> n'a pas été modifié. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
        $etat = 'nok';
      }
    }
    // Déplacement du répertoire si $_REQUEST['parent'] non nul et si pas à la racine
    if ( $r['parent'] && isset($_REQUEST['parent']) && !in_array($parent = intval($_REQUEST['parent']),array(0,$id,$r['parent'])) )  {
      // Vérification du répertoire parent
      $resultat = $mysqli->query("SELECT parents, matiere FROM reps WHERE id = $parent AND FIND_IN_SET(matiere,'${_SESSION['matieres']}') AND NOT FIND_IN_SET($id,parents)");
      if ( $resultat->num_rows)  {
        $s = $resultat->fetch_assoc();
        $resultat->free();
        $mat = $s['matiere'];
        $parents = "${s['parents']},$parent";
        if ( requete('reps',"UPDATE reps SET matiere = $mat, parent = $parent, parents = '$parents' WHERE id = $id",$mysqli)
          && requete('reps',"UPDATE reps SET matiere = $mat, parents = '$parents,$id' WHERE parent = $id",$mysqli)
          && requete('docs',"UPDATE docs SET matiere = $mat, parents = '$parents,$id' WHERE parent = $id",$mysqli)
          && $mysqli->query('UPDATE matieres SET docs = (SELECT IF(COUNT(*),1,0) FROM docs WHERE matiere = matieres.id AND protection < 32)') )
          $message[] = "Le répertoire <em>${r['nom']}</em> a été déplacé.";
        else  {
          $message[] = "Le répertoire <em>${r['nom']}</em> n'a pas été déplacé. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
          $etat = 'nok';
        }
      }
      else  {
        $message[] = "Le répertoire <em>${r['nom']}</em> n'a pas été déplacé. Identifiant de répertoire parent non valide.";
        $etat = 'nok';
      }
    }
    // Reconstruction du message
    if ( $message )  {
      // Mise à jour de l'ordre des répertoires
      $mysqli->query('ALTER TABLE reps ORDER BY parents,nom');
      if ( $etat == 'nok')
        exit('{"etat":"nok","message":"'.implode(', ',$message).'"}');
      // Modification de la matière si protection du répertoire racine modifié
      if ( !$r['parent'] && $r['matiere'] && $protection != $r['protection'] )
        requete('matieres',"UPDATE matieres SET docs_protection = $protection WHERE id = ${r['matiere']}",$mysqli);
      exit($_SESSION['message'] = '{"etat":"ok","message":"'.implode(', ',$message).'"}');
    }
    exit("{\"etat\":\"nok\",\"message\":\"Le répertoire <em>${r['nom']}</em> n'a pas été modifié. Aucune modification demandée.\"}");
  }
  
  // Propagation des droits d'accès aux sous-répertoires et documents
  // Les infos récentes sont modifiées dans la base, mais les flux RSS
  // ne seront affectés qu'à la prochaine exécution de recents() et donc rss()
  if ( isset($_REQUEST['propage']) )  {
    if ( requete('reps',"UPDATE reps SET protection = ${r['protection']} WHERE FIND_IN_SET($id,parents)",$mysqli) && requete('docs',"UPDATE docs SET protection = ${r['protection']} WHERE FIND_IN_SET($id,parents)",$mysqli) )  {
      // Mise à jour des informations récentes
      requete('recents',"UPDATE recents SET protection = ${r['protection']} WHERE id IN (SELECT 3000+docs.id FROM docs WHERE FIND_IN_SET($id,parents))",$mysqli);
      rss($mysqli, ( $r['matiere'] == 0 ) ? array(0) : array(0,$r['matiere']) );
      // Mise à jour de la matière (menu)
      $mysqli->query('UPDATE matieres SET docs = (SELECT IF(COUNT(*),1,0) FROM docs WHERE matiere = matieres.id AND protection < 32)');
      exit($_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"Le réglage d'accès du répertoire <em>${r['nom']}</em> a été propagé à tous les documents et sous-répertoires qu'il contient.\"}");
    }
    exit("{\"etat\":\"nok\",\"message\":\"Le réglage d'accès du répertoire <em>${r['nom']}</em> n'a pas été propagé. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
  }

  // Suppression du répertoire ou de son contenu
  if ( isset($_REQUEST['supprime']) || isset($_REQUEST['vide']) )  {
    if ( isset($_REQUEST['supprime']) )  {
      if ( !$r['parent'] )
        exit('{"etat":"nok","message":"Les répertoires racine des matières ne sont pas supprimables."}');
      $action = 'supprimé';
      $requete = "id = $id OR";
    }
    else  {
      $action = 'vidé';
      $requete = '';
    }
    if ( requete('reps',"DELETE FROM reps WHERE $requete FIND_IN_SET($id,parents)",$mysqli) )  {
      // Suppression physique
      $resultat = $mysqli->query("SELECT lien FROM docs WHERE FIND_IN_SET($id,parents)");
      if ( $resultat->num_rows )  {
        while ( $s = $resultat->fetch_row() )
          exec("rm -rf documents/${s[0]}");
        $resultat->free();
        if ( !requete('docs',"DELETE FROM docs WHERE FIND_IN_SET($id,parents)",$mysqli) )
          exit("{\"etat\":\"nok\",\"message\":\"Le répertoire <em>${r['nom']}</em> n'a pas été correctement $action. Certains documents sont encore dans la base de données. Vous devriez en informer l'administrateur. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
      }
      $mysqli->query('UPDATE matieres SET docs = (SELECT IF(COUNT(*),1,0) FROM docs WHERE matiere = matieres.id AND protection < 32)');
      if ( $action == 'vidé' )
        exit($_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"Le répertoire <em>${r['nom']}</em> a été vidé de son contenu, ainsi que tous ses sous-répertoires.\"}");
      exit("{\"etat\":\"ok\",\"message\":\"Le répertoire <em>${r['nom']}</em> a été supprimé, ainsi que tous ses sous-répertoires et ses documents.\"}");
    }
    else
      exit("{\"etat\":\"nok\",\"message\":\"Le répertoire <em>${r['nom']}</em> n'a pas été $action. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
  }
}

///////////////////////////
// Ajout d'un répertoire //
///////////////////////////
elseif ( ( $action == 'ajout-rep' ) && isset($_REQUEST['nom']) && isset($_REQUEST['protection']) && isset($_REQUEST['parent']) && strlen($nom = trim($mysqli->real_escape_string($_REQUEST['nom']))) && ctype_digit($parent=$_REQUEST['parent']) )  {
  // Vérification du répertoire parent
  $resultat = $mysqli->query("SELECT parents, matiere, protection FROM reps WHERE id = $parent AND FIND_IN_SET(matiere,'${_SESSION['matieres']}')");
  if ( !$resultat->num_rows )
    exit('{"etat":"nok","message":"Identifiant de répertoire parent non valide"}');
  $r = $resultat->fetch_assoc();
  $resultat->free();
  $menu = intval(isset($_REQUEST['menu']));
  // Génération de la valeur de protection
  if ( count($val = array_filter($_REQUEST['protection'],function($id) { return ctype_digit($id); })) )  {
    if ( ( $val[0] == 0 ) || ( $val[0] == 32 ) )
      $protection = $val[0];
    else  {
      $protection = 32;
      foreach (array_slice($val,1) as $v) 
        $protection = $protection-2**($v-1);
    }
  }
  else
    $protection = $r['protection'];
  if ( !requete('reps',"INSERT INTO reps SET parent = $parent, parents = '${r['parents']},$parent', nom = '$nom', matiere = ${r['matiere']}, protection = $protection, menu = $menu",$mysqli) )
    exit('{"etat":"nok","message":"Le répertoire n\'a pas été ajouté. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
  // Mise à jour
  $mysqli->query('ALTER TABLE reps ORDER BY parents,nom');
  exit($_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"Le répertoire <em>$nom</em> a été ajouté.\"}");
}

////////////////////////////////
// Modification des documents //
////////////////////////////////
elseif ( ( $action == 'docs' ) && isset($_REQUEST['id']) && ctype_digit($id = $_REQUEST['id']) )  {
  // Vérification de l'identifiant
  $resultat = $mysqli->query("SELECT nom, protection, ext, lien, parent, matiere FROM docs WHERE id = $id AND FIND_IN_SET(matiere,'${_SESSION['matieres']}')");
  if ( !$resultat->num_rows )
    exit('{"etat":"nok","message":"Identifiant de document non valide"}');
  $r = $resultat->fetch_assoc();
  $resultat->free();

  // Traitement d'une modification unique (nom)
  if ( isset($_REQUEST['champ']) && ( $_REQUEST['champ'] == 'nom' ) )  {
    if ( !strlen( $valeur = trim($_REQUEST['val']) ) )
      exit("{\"etat\":\"nok\",\"message\":\"Le nom du document <em>${r['nom']}</em> n'a pas été modifié. Le nom doit être non vide.\"}");
    if ( $valeur != $r['nom'] )  {
      setlocale(LC_CTYPE, "fr_FR.UTF-8");
      $nom = substr((str_replace(array($r['ext'],'\\','/'),array('','-','-'),$valeur)),0,100);
      // real_escape_string seulement pour la requête SQL
      $nouveau_nom = $mysqli->real_escape_string($nom);
      if ( !requete('docs',"UPDATE docs SET nom = '$nouveau_nom', nom_nat = '".zpad($nouveau_nom)."' WHERE id = $id",$mysqli) )
        exit("{\"etat\":\"nok\",\"message\":\"Le nom du document <em>${r['nom']}</em> n'a pas été modifié. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
      exec('mv documents/'.escapeshellarg("${r['lien']}/${r['nom']}${r['ext']}").' documents/'.escapeshellarg("${r['lien']}/$nom${r['ext']}"));
      $mysqli->query('ALTER TABLE docs ORDER BY parents,nom_nat');
      // Modification de l'éventuelle information récente
      if ( $r['protection'] < 32 )
        recent($mysqli,3,$id,$r['matiere'],array('nom'=>$nouveau_nom,'ancien_nom'=>$r['nom']));
      exit("{\"etat\":\"ok\",\"message\":\"Le nom du document <em>${r['nom']}</em> a été modifié.\"}");
    }
    exit("{\"etat\":\"nok\",\"message\":\"Le nom du document <em>${r['nom']}</em> n'a pas été modifié. Aucune modification demandée.\"}");
  }

  // Traitement d'une modification globale
  if ( isset($_REQUEST['nom']) && isset($_REQUEST['parent']) && isset($_REQUEST['protection']) && strlen($nom = trim($_REQUEST['nom'])) )  {
    $requete = $message = array();
    $etat = 'ok';
    // Modification du nom
    setlocale(LC_CTYPE, "fr_FR.UTF-8");
    $nom = substr(basename(str_replace(array($r['ext'],'\\'),array('','/'),$nom)),0,100);
    if ( $nom != $r['nom'] )  {
      // real_escape_string seulement pour la requête SQL
      $nouveau_nom = $mysqli->real_escape_string($nom);
      if ( requete('docs',"UPDATE docs SET nom = '$nouveau_nom', nom_nat = '".zpad($nouveau_nom)."' WHERE id = $id",$mysqli) )  {
        exec('mv documents/'.escapeshellarg("${r['lien']}/${r['nom']}${r['ext']}").' documents/'.escapeshellarg("${r['lien']}/$nom${r['ext']}"));
        $message[] = "Le nom du document <em>${r['nom']}</em> a été modifié.";
        // Modification de l'éventuelle information récente
        if ( $r['protection'] < 32 )
          recent($mysqli,3,$id,$r['matiere'],array('nom'=>$nouveau_nom,'ancien_nom'=>$r['nom']));
      }
      else  {
        $message[] = "Le nom du document <em>${r['nom']}</em> n'a pas été modifié. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
        $etat = 'nok';
      }
    }
    // Modification de la protection
    if ( count($val = array_filter($_REQUEST['protection'],function($id) { return ctype_digit($id); })) )  {
      if ( ( $val[0] == 0 ) || ( $val[0] == 32 ) )
        $protection = $val[0];
      else  {
        $protection = 32;
        foreach (array_slice($val,1) as $v) 
          $protection = $protection-2**($v-1);
      }
      if ( $protection != $r['protection'] )  {
        if ( requete('docs',"UPDATE docs SET protection = $protection WHERE id = $id",$mysqli) )  {
          $message[] = "L'accès au document <em>${r['nom']}</em> a été modifié.";
          // Si $protection = 32, on cherche à supprimer l'info récente
          if ( $protection == 32 )
            recent($mysqli,3,$id,$r['matiere']);
          // Si doc avant protégé, on crée une info récente de nouveau doc
          elseif ( $r['protection'] == 32 )  {
            $resultat = $mysqli->query("SELECT GROUP_CONCAT( reps.nom ORDER BY FIND_IN_SET(reps.id,docs.parents) SEPARATOR '/' ) AS path, docs.nom
                                        FROM docs LEFT JOIN reps ON FIND_IN_SET(reps.id,docs.parents) WHERE docs.id = $id");
            $s = $resultat->fetch_assoc();
            $resultat->free();
            $path = $mysqli->real_escape_string("${s['path']}/${s['nom']}");
            recent($mysqli,3,$id,$r['matiere'],array('titre'=>$path, 'lien'=>"download?id=$id", 'texte'=>"<p>Nouveau document&nbsp;: <a href=\"download?id=$id\">$path</a></p>", 'matiere'=>$r['matiere'], 'protection'=>$protection),$r['ext']);
          }
          // Sinon, mise à jour de la protection dans les informations récentes
          else
            recent($mysqli,3,$id,$r['matiere'],array('protection'=>$protection));
        }
        else  {
          $message[] = "L'accès au document <em>${r['nom']}</em> n'a pas été modifié. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
          $etat = 'nok';
          $protection = $r['protection'];
        }
      }
    }

    // Déplacement dans un autre répertoire
    if ( ctype_digit($parent = $_REQUEST['parent']) && $parent && ( $parent != $r['parent'] ) )  {
      // Vérification du répertoire parent
      $resultat = $mysqli->query("SELECT parents, matiere FROM reps WHERE id = $parent AND FIND_IN_SET(matiere,'${_SESSION['matieres']}')");
      if ( $resultat->num_rows )  {
        $s = $resultat->fetch_assoc();
        $resultat->free();
        if ( requete('docs',"UPDATE docs SET parent = '$parent', parents = '${s['parents']},$parent', matiere = ${s['matiere']} WHERE id = $id",$mysqli) )  {
          $message[] = "Le document <em>${r['nom']}</em> a été déplacé.";
          // Modification de l'information récente si document visible
          if ( $protection < 32 )  {
            $resultat = $mysqli->query("SELECT GROUP_CONCAT( reps.nom ORDER BY FIND_IN_SET(reps.id,docs.parents) SEPARATOR '/' ) AS path, docs.nom, docs.matiere
                                        FROM docs LEFT JOIN reps ON FIND_IN_SET(reps.id,docs.parents) WHERE docs.id = $id");
            $s = $resultat->fetch_assoc();
            $resultat->free();
            recent($mysqli,3,$id,$r['matiere'],array('chemin'=>$mysqli->real_escape_string("${s['path']}/${s['nom']}"), 'matiere'=>$s['matiere']));
          }
        }
        else  {
          $message[] = "Le document <em>${r['nom']}</em> n'a pas été déplacé. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
          $etat = 'nok';
        }
      }
      else  {
        $message[] = "Le document <em>${r['nom']}</em> n'a pas été déplacé. Identifiant de répertoire parent non valide.";
        $etat = 'nok';
      }
    }
    // Mise à jour d'un document
    if ( isset($_FILES['fichier']['tmp_name']) && is_uploaded_file($_FILES['fichier']['tmp_name']) )  {
      // Changement d'extension interdit
      $ext = ( strpos($_FILES['fichier']['name'],'.') ) ? strrchr($_FILES['fichier']['name'],'.') : '';
      if ( $ext != $r['ext'] )  {
        $message[] = "Le document <em>${r['nom']}</em> n'a pas été mis à jour. Le fichier envoyé est d'une extension différente.";
        $etat = 'nok';
      }
      // Déplacement du document uploadé au bon endroit
      elseif ( move_uploaded_file($_FILES['fichier']['tmp_name'],"documents/${r['lien']}/${r['nom']}${r['ext']}") )  {
        // Gestion de la taille
        $taille = intval($_FILES['fichier']['size']/1024);
        $taille = ( $taille < 1024 ) ? "$taille&nbsp;ko" : intval($taille/1024).'&nbsp;Mo';
        // Modifications dans la base de données
        requete('docs',"UPDATE docs SET upload = CURDATE(), taille = '$taille' WHERE id = $id",$mysqli);
        // Info récente si document visible (éventuellement nouvelle)
        if ( $protection < 32 )  {
          // Besoin du chemin si pas d'info récente liée au document
          $resultat = $mysqli->query("SELECT GROUP_CONCAT( reps.nom ORDER BY FIND_IN_SET(reps.id,docs.parents) SEPARATOR '/' ) AS path, docs.nom
                                      FROM docs LEFT JOIN reps ON FIND_IN_SET(reps.id,docs.parents) WHERE docs.id = $id");
          $s = $resultat->fetch_assoc();
          $resultat->free();
          recent($mysqli,3,$id,$r['matiere'],array('maj'=>$mysqli->real_escape_string("${s['path']}/${s['nom']}")));
        }
        $message[] = "Le document <em>${r['nom']}</em> a été mis à jour.";
      }
      else  {
        $message[] = "Le document <em>$nom</em> n'a pas été mis à jour : problème d'écriture du fichier. Vous devriez en informer l'administrateur.";
        $etat = 'nok';
      }
    }
    // Reconstruction du message
    if ( $message )  {
      // Mise à jour de l'ordre des répertoires et de l'affichage des matières
      $mysqli->query('ALTER TABLE docs ORDER BY parents,nom_nat');
      $mysqli->query('UPDATE matieres SET docs = (SELECT IF(COUNT(*),1,0) FROM docs WHERE matiere = matieres.id AND protection < 32)');
      if ( $etat == 'nok')
        exit('{"etat":"nok","message":"'.implode(', ',$message).'"}');
      exit($_SESSION['message'] = '{"etat":"ok","message":"'.implode(', ',$message).'"}');
    }
    exit("{\"etat\":\"nok\",\"message\":\"Le document <em>${r['nom']}</em> n'a pas été modifié. Aucune modification demandée.\"}");
  }
  
  // Suppression d'un document
  if ( isset($_REQUEST['supprime']) )  {
    if ( !requete('docs',"DELETE FROM docs WHERE id = $id",$mysqli) )
      exit("{\"etat\":\"nok\",\"message\":\"Le document <em>${r['nom']}</em> n'a pas été supprimé. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».');
    // Suppression physique
    exec("rm -rf documents/${r['lien']}");
    recent($mysqli,3,$id,$r['matiere']);
    $mysqli->query('UPDATE matieres SET docs = (SELECT IF(COUNT(*),1,0) FROM docs WHERE matiere = matieres.id AND protection < 32)');
    exit("{\"etat\":\"ok\",\"message\":\"Le document <em>${r['nom']}</em> a été supprimé.\"}");
  }
}

/////////////////////////
// Ajout d'un document //
/////////////////////////
elseif ( ( $action == 'ajout-doc' ) && isset($_FILES['fichier']['tmp_name']) && is_uploaded_file($_FILES['fichier']['tmp_name']) && isset($_REQUEST['nom']) && isset($_REQUEST['protection']) && isset($_REQUEST['parent']) && ctype_digit($parent = $_REQUEST['parent']) )  {
  // Vérification du répertoire parent
  $resultat = $mysqli->query("SELECT parents, matiere, protection FROM reps WHERE id = $parent AND FIND_IN_SET(matiere,'${_SESSION['matieres']}')");
  if ( !$resultat->num_rows )
    exit('{"etat":"nok","message":"Identifiant de répertoire parent non valide"}');
  $r = $resultat->fetch_assoc();
  $resultat->free();
  // Vérifications des données envoyées (on fait confiance aux utilisateurs connectés pour ne pas envoyer de scripts malsains)
  $nom = $_FILES['fichier']['name'];
  // $ext ne doit pas faire plus de 4 caractères sinon fichier plus accessible
  $ext = ( strpos($nom,'.') ) ? substr(strrchr($nom,'.'),0,4) : '';
  setlocale(LC_CTYPE, "fr_FR.UTF-8");
  $nom = trim(substr(basename(str_replace(array($ext,'\\'),array('','/'), $_REQUEST['nom'] ?: $nom )),0,100));
  // Génération de la valeur de protection
  if ( count($val = array_filter($_REQUEST['protection'],function($id) { return ctype_digit($id); })) )  {
    if ( ( $val[0] == 0 ) || ( $val[0] == 32 ) )
      $protection = $val[0];
    else  {
      $protection = 32;
      foreach (array_slice($val,1) as $v) 
        $protection = $protection-2**($v-1);
    }
  }
  else
    $protection = $r['protection'];
  // Création du répertoire particulier
  $lien = substr(sha1(mt_rand()),0,15);
  while ( is_dir("documents/$lien") )
    $lien = substr(sha1(mt_rand()),0,15);
  mkdir("documents/$lien");
  // Gestion de la taille
  $taille = intval($_FILES['fichier']['size']/1024);
  $taille = ( $taille < 1024 ) ? "$taille&nbsp;ko" : intval($taille/1024).'&nbsp;Mo';
  // Déplacement du document uploadé au bon endroit
  if ( !move_uploaded_file($_FILES['fichier']['tmp_name'],"documents/$lien/$nom$ext") )
    exit("{\"etat\":\"nok\",\"message\":\"Le document <em>$nom</em> n'a pas été ajouté : problème d'écriture du fichier. Vous devriez en informer l'administrateur.\"}");
  // Écriture MySQL
  if ( requete('docs',"INSERT INTO docs SET parent = $parent, parents = '${r['parents']},$parent',
                       matiere = ${r['matiere']}, nom = '".$mysqli->real_escape_string($nom).'\', nom_nat = \''.zpad($mysqli->real_escape_string($nom))."', upload = CURDATE(),
                       taille = '$taille', lien = '$lien', ext='".$mysqli->real_escape_string($ext)."', protection = $protection",$mysqli) )  {
    $id = $mysqli->insert_id;
    // Mise à jour des informations récentes
    if ( $protection < 32 )  {
      $resultat = $mysqli->query("SELECT GROUP_CONCAT( reps.nom ORDER BY FIND_IN_SET(reps.id,docs.parents) SEPARATOR '/' ) AS path
                                  FROM docs LEFT JOIN reps ON FIND_IN_SET(reps.id,docs.parents) WHERE docs.id = $id");
      $s = $resultat->fetch_assoc();
      $resultat->free();
      $path = $mysqli->real_escape_string("${s['path']}/$nom");
      recent($mysqli,3,$id,$r['matiere'],array('titre'=>$path, 'lien'=>"download?id=$id", 'texte'=>"<p>Nouveau document&nbsp;: <a href=\"download?id=$id\">$path</a></p>", 'matiere'=>$r['matiere'], 'protection'=>$protection),$ext);
      // Mise à jour de l'affichage de la matière dans le menu)
      $mysqli->query("UPDATE matieres SET docs = 1 WHERE id = ${r['matiere']}");
    }
    $mysqli->query('ALTER TABLE docs ORDER BY parents,nom_nat');
    exit($_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"Le document <em>$nom</em> a été ajouté.\"}");
  }
  else  {
    // Retour en arrière
    exec("rm -rf documents/$lien");
    exit("{\"etat\":\"nok\",\"message\":\"Le document <em>$nom</em> n'a pas été ajouté. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
  }
}

///////////////////////////////////////////
// Modification des programmes de colles //
///////////////////////////////////////////
elseif ( ( $action == 'colles' ) && isset($_REQUEST['id']) && ctype_digit($sid = strstr($_REQUEST['id'],'-',true)) && in_array($mid = intval(substr(strstr($_REQUEST['id'],'-'),1)), explode(',',$_SESSION['matieres'])) )  {
  // L'identifiant est sous la forme semaine-matiere, pour assurer une
  // cohérence entre les programmes saisis et ceux non saisis/supprimés
  $resultat = $mysqli->query("SELECT DATE_FORMAT(s.debut,'%e/%m') AS debut, c.id, c.cache, c.texte
                              FROM semaines AS s LEFT JOIN colles AS c ON c.semaine = s.id
                              WHERE s.id = $sid AND c.matiere = $mid");
  if ( !$resultat->num_rows )
    exit('{"etat":"nok","message":"Identifiant non valide"}');
  $r = $resultat->fetch_assoc();
  $resultat->free();
  // Chaine de mise à jour de la matière
  $requete_maj = "UPDATE matieres SET colles = IF((SELECT id FROM colles WHERE matiere = $mid AND cache = 0 LIMIT 1),1,0) WHERE id = $mid AND colles_protection < 32";

  // Traitement d'une modification unique (texte)
  if ( isset($_REQUEST['champ']) && ( $_REQUEST['champ'] == 'texte' ) )  {
    $valeur = $mysqli->real_escape_string($_REQUEST['val']);
    if ( !strlen($valeur) )
      exit("{\"etat\":\"nok\",\"message\":\"Le programme de colle de la semaine du ${r['debut']} n'a pas été modifié. Le texte doit être non vide.\"}");
    if ( requete('colles',"UPDATE colles SET texte = '$valeur' WHERE id = ${r['id']}",$mysqli) )  {
      if ( !$r['cache'] )
        recent($mysqli,2,$r['id'],$mid,array('texte'=>$valeur));
      exit("{\"etat\":\"ok\",\"message\":\"Le programme de colle de la semaine du ${r['debut']} a été modifié.\"}");
    }
    exit("{\"etat\":\"nok\",\"message\":\"Le programme de colle de la semaine du ${r['debut']} n'a pas été modifié. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
  }

  // Positionnement "montré" (apparaît sur la partie publique)
  if ( isset($_REQUEST['montre']) )  {
    if ( requete('colles',"UPDATE colles SET cache = 0 WHERE id = ${r['id']}",$mysqli) )  {
      // Fabrication des données pour les informations récentes
      $resultat = $mysqli->query("SELECT nom, cle, colles_protection FROM matieres WHERE id = $mid");
      $s = $resultat->fetch_assoc();
      $resultat->free();
      recent($mysqli,2,$r['id'],$mid,array('titre'=>"Colles du ${r['debut']} en ".$mysqli->real_escape_string($s['nom']), 'lien'=>"colles?${s['cle']}&amp;n=$sid", 'texte'=>$mysqli->real_escape_string($r['texte']), 'matiere'=>$mid, 'protection'=>$s['colles_protection']));
      $mysqli->query($requete_maj);
      exit("{\"etat\":\"ok\",\"message\":\"Le programme de colle de la semaine du ${r['debut']} apparaît désormais sur la partie publique.\"}");
    }
    exit("{\"etat\":\"nok\",\"message\":\"Le programme de colle de la semaine du ${r['debut']} n'a pas été diffusé. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
  }

  // Positionnement "caché" (n'apparaît pas sur la partie publique)
  if ( isset($_REQUEST['cache']) )  {
    if ( requete('colles',"UPDATE colles SET cache = 1 WHERE id = ${r['id']}",$mysqli) )  {
      recent($mysqli,2,$r['id'],$mid);
      $mysqli->query($requete_maj);
      exit("{\"etat\":\"ok\",\"message\":\"Le programme de colle de la semaine du ${r['debut']} n'apparaît plus sur la partie publique mais est toujours disponible ici pour modification ou diffusion.\"}");
    }
    exit("{\"etat\":\"nok\",\"message\":\"Le programme de colle de la semaine du ${r['debut']} n'a pas été caché. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
  }

  // Suppression
  if ( isset($_REQUEST['supprime']) )  {
    if ( requete('colles',"DELETE FROM colles WHERE id = ${r['id']}",$mysqli) )  {
      recent($mysqli,2,$r['id'],$mid);
      $mysqli->query($requete_maj);
      exit("{\"etat\":\"ok\",\"message\":\"Le programme de colle de la semaine du ${r['debut']} a été supprimé.\"}");
    }
    exit("{\"etat\":\"nok\",\"message\":\"Le programme de colle de la semaine du ${r['debut']} n'a pas été supprimé. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
  }
}

////////////////////////////////////
// Ajout d'un programme de colles //
////////////////////////////////////
elseif ( ( $action == 'ajout-colle' ) && isset($_REQUEST['id']) && ctype_digit($sid = strstr($_REQUEST['id'],'-',true)) && in_array($mid = intval(substr(strstr($_REQUEST['id'],'-'),1)), explode(',',$_SESSION['matieres'])) )  {
  // L'identifiant est sous la forme semaine-matiere, pour assurer une
  // cohérence entre les programmes saisis et ceux non saisis/supprimés
  $resultat = $mysqli->query("SELECT DATE_FORMAT(debut,'%e/%m') AS debut FROM semaines WHERE id = $sid AND colle");
  if ( !$resultat->num_rows )
    exit('{"etat":"nok","message":"Identifiant non valide"}');
  $r = $resultat->fetch_assoc();
  $resultat->free();
  // Validation des données
  $texte = $mysqli->real_escape_string($_REQUEST['texte']);
  $cache = intval(isset($_REQUEST['cache']));
  if ( !strlen($texte) )
    exit("{\"etat\":\"nok\",\"message\":\"Le programme de colle de la semaine du ${r['debut']} n'a pas été ajouté. Le texte doit être non vide.\"}");
  if ( requete('colles',"INSERT INTO colles SET texte = '$texte', semaine = $sid, matiere = $mid, cache = $cache",$mysqli) )  {
    $id = $mysqli->insert_id;
    $mysqli->query('ALTER TABLE colles ORDER BY matiere,semaine');
    if ( !$cache )  {
      // Fabrication des données pour les informations récentes
      $resultat = $mysqli->query("SELECT nom, cle, colles_protection FROM matieres WHERE id = $mid");
      $s = $resultat->fetch_assoc();
      $resultat->free();
      recent($mysqli,2,$id,$mid,array('titre'=>"Colles du ${r['debut']} en ".$mysqli->real_escape_string($s['nom']), 'lien'=>"colles?${s['cle']}&amp;n=$sid", 'texte'=>$texte, 'matiere'=>$mid, 'protection'=>$s['colles_protection']));
      // Mise à jour de la matière
      $mysqli->query("UPDATE matieres SET colles = IF((SELECT id FROM colles WHERE matiere = $mid AND cache = 0 LIMIT 1),1,0) WHERE id = $mid AND colles_protection < 32");
    }
    exit("{\"etat\":\"ok\",\"message\":\"Le programme de colle de la semaine du ${r['debut']} a été ajouté.\"}");
  }
  exit("{\"etat\":\"nok\",\"message\":\"Le programme de colle de la semaine du ${r['debut']} n'a pas été ajouté. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
}

/////////////////////////////////////////////////////////
// Modification ou ajout des éléments cahiers de texte //
/////////////////////////////////////////////////////////
elseif ( $action == 'cdt-elems' )  {

  // Traitement d'une modification de propriétés/d'un ajout d'élément :
  // validation préliminaire
  if ( isset($_REQUEST['tid']) && ctype_digit($tid = $_REQUEST['tid']) && isset($_REQUEST['jour']) )  {
    // Validation du jour de la semaine
    $jour = preg_filter('/(\d{2})\/(\d{2})\/(\d{4})/','$3-$2-$1',$_REQUEST['jour']);
    $resultat = $mysqli->query("SELECT id FROM semaines WHERE debut <= '$jour' AND debut >= SUBDATE('$jour',7) ORDER BY debut DESC LIMIT 1");
    if ( !$resultat->num_rows )
      exit('{"etat":"nok","message":"Le jour choisi ne se trouve pas dans l\'année scolaire. S\'il s\'agit d\'une erreur, il faut peut-être contacter l\'administrateur."}');
    $r = $resultat->fetch_assoc();
    $semaine = $r['id'];
    $resultat->free();
    // Validation du type de séance
    $resultat = $mysqli->query("SELECT id, deb_fin_pour FROM `cdt-types` WHERE id = $tid AND FIND_IN_SET(matiere,'${_SESSION['matieres']}')");
    if ( !$resultat->num_rows )
      exit('{"etat":"nok","message":"Type de séance non valide."}');
    $r = $resultat->fetch_assoc();
    $resultat->free();
    // Validation des horaires
    $h_debut = $h_fin = '0:00';
    $pour = '0000/00/00';
    $demigroupe = 0;
    switch ( $r['deb_fin_pour'] )  {
      case 1: $h_fin = preg_filter('/(\d{1,2})h(\d{2})/','$1:$2',$_REQUEST['h_fin']);
      case 0: $h_debut = preg_filter('/(\d{1,2})h(\d{2})/','$1:$2',$_REQUEST['h_debut']); $demigroupe = intval($_REQUEST['demigroupe'] == 1); break;
      case 2: $pour = preg_filter('/(\d{2})\/(\d{2})\/(\d{4})/','$3-$2-$1',$_REQUEST['pour']);
      case 3: $demigroupe = intval($_REQUEST['demigroupe'] == 1);
      // Cas 4 et 5 : h_debut, h_fin et pour restent nuls (cf l'aide)
    }
  }

  // Vérification que l'identifiant est valide
  if ( isset($_REQUEST['id']) && ctype_digit($id = $_REQUEST['id']) )  {
    $resultat = $mysqli->query("SELECT id, type, matiere FROM cdt WHERE id = $id AND FIND_IN_SET(matiere,'${_SESSION['matieres']}')");
    if ( !$resultat->num_rows )
      exit('{"etat":"nok","message":"Identifiant de l\'élément de cahier de texte non valide"}');
    $r = $resultat->fetch_assoc();
    $resultat->free();

    // Traitement d'une modification de propriétés
    if ( isset($h_debut) )  {
      // Écriture dans la base de données
      if ( requete('cdt',"UPDATE cdt SET semaine = $semaine, jour = '$jour', h_debut = '$h_debut', h_fin = '$h_fin',
                          pour = '$pour', type = $tid, demigroupe = $demigroupe WHERE id = $id", $mysqli) )  {
        // Mise à jour du compte d'éléments si modification du type
        if ( $tid != $r['type'] )  {
          $mysqli->query("UPDATE `cdt-types` SET nb = nb-1 WHERE id = ${r['type']}");
          $mysqli->query("UPDATE `cdt-types` SET nb = nb+1 WHERE id = $tid");
        }
        // Mise en ordre : d'abord ce qui n'a pas de fin, ensuite les
        // séances "normales", ensuite les "pour le"
        $mysqli->query('ALTER TABLE cdt ORDER BY jour,matiere,pour,h_debut,h_fin,type');
        exit('{"etat":"ok","message":"Les propriétés de l\'élément du cahier de texte ont été modifiées."}');
      }
      exit('{"etat":"nok","message":"Les propriétés de l\'élément du cahier de texte n\'ont pas été modifiées. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
    }

    // Traitement d'une modification de texte
    if ( isset($_REQUEST['champ']) && ( $_REQUEST['champ'] == 'texte' ) )  {
      if ( !strlen($valeur = $mysqli->real_escape_string($_REQUEST['val'])) )
        exit('{"etat":"nok","message":"L\'élément du cahier de texte n\'a pas été modifié. Le texte doit être non vide."}');
      if ( requete('cdt',"UPDATE cdt SET texte = '$valeur' WHERE id = $id",$mysqli) )
        exit('{"etat":"ok","message":"Le texte de l\'élément du cahier de texte a été modifié."}');
      exit('{"etat":"nok","message":"Le texte de l\'élément du cahier de texte n\'a pas été modifié. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
    }

    // Positionnement "montré" (apparaît sur la partie publique)
    if ( isset($_REQUEST['montre']) )  {
      if ( requete('cdt',"UPDATE cdt SET cache = 0 WHERE id = $id",$mysqli) )  {
        $mysqli->query("UPDATE matieres SET cdt = IF((SELECT id FROM cdt WHERE matiere = ${r['matiere']} AND cache = 0 LIMIT 1),1,0) WHERE id = ${r['matiere']} AND cdt_protection < 32");
        exit('{"etat":"ok","message":"L\'élément du cahier de texte apparaît désormais sur la partie publique."}');
      }
      exit('{"etat":"nok","message":"L\'élément du cahier de texte n\'a pas été diffusé. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
    }

    // Positionnement "caché" (n'apparaît pas sur la partie publique)
    if ( isset($_REQUEST['cache']) )  {
      if ( requete('cdt',"UPDATE cdt SET cache = 1 WHERE id = $id",$mysqli) )  {
        $mysqli->query("UPDATE matieres SET cdt = IF((SELECT id FROM cdt WHERE matiere = ${r['matiere']} AND cache = 0 LIMIT 1),1,0) WHERE id = ${r['matiere']} AND cdt_protection < 32");
        exit('{"etat":"ok","message":"L\'élément du cahier de texte n\'apparaît plus sur la partie publique mais est toujours disponible ici pour modification ou diffusion."}');
      }
      exit('{"etat":"nok","message":"L\'élément du cahier de texte n\'a pas été caché. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
    }

    // Suppression
    elseif ( isset($_REQUEST['supprime']) )  {
      if ( requete('cdt',"DELETE FROM cdt WHERE id = $id",$mysqli) )  {
        $mysqli->query("UPDATE `cdt-types` SET nb = nb-1 WHERE id = ${r['type']}");
        $mysqli->query("UPDATE matieres SET cdt = IF((SELECT id FROM cdt WHERE matiere = ${r['matiere']} AND cache = 0 LIMIT 1),1,0) WHERE id = ${r['matiere']} AND cdt_protection < 32");
        exit('{"etat":"ok","message":"L\'élément du cahier de texte a été supprimé."}');
      }
      exit('{"etat":"nok","message":"L\'élément du cahier de texte n\'a pas été supprimé. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
    }
  }
  
  // Nouvel élément du cahier de texte
  elseif ( isset($demigroupe) && isset($_REQUEST['matiere']) && in_array($matiere = intval($_REQUEST['matiere']), explode(',',$_SESSION['matieres'])) )  {
    $cache = intval(isset($_REQUEST['cache']));
    if ( !strlen($texte = $mysqli->real_escape_string($_REQUEST['texte'])) )
      exit('{"etat":"nok","message":"L\'élément du cahier de texte n\'a pas été ajouté. Le texte doit être non vide."}');
    if ( is_null($h_debut) )
      exit('{"etat":"nok","message":"L\'élément du cahier de texte n\'a pas été ajouté. L\'horaire de début doit être non vide."}');
    if ( is_null($h_fin) )
      exit('{"etat":"nok","message":"L\'élément du cahier de texte n\'a pas été ajouté. L\'horaire de fin doit être non vide."}');
    if ( is_null($pour) )
      exit('{"etat":"nok","message":"L\'élément du cahier de texte n\'a pas été ajouté. La date d\'échéance doit être non vide."}');
    // Écriture dans la base de données
    if ( requete('cdt',"INSERT INTO cdt SET matiere = $matiere, semaine = $semaine, jour = '$jour', h_debut = '$h_debut', h_fin = '$h_fin',
                            pour = '$pour', type = $tid, texte = '$texte', demigroupe = $demigroupe, cache = $cache", $mysqli) )  {
      // Mises à jour : nombre d'éléments du type, ordre des éléments (d'abord
      // ce qui n'a pas de fin, ensuite les séances "normales", ensuite les
      // "pour le"), champ cdt de la matière
      $mysqli->query("UPDATE `cdt-types` SET nb = nb+1 WHERE id = $tid");
      $mysqli->query('ALTER TABLE cdt ORDER BY jour,matiere,pour,h_debut,h_fin,type');
      $mysqli->query("UPDATE matieres SET cdt = IF((SELECT id FROM cdt WHERE matiere = $matiere AND cache = 0 LIMIT 1),1,0) WHERE id = $matiere AND cdt_protection < 32");
      exit($_SESSION['message'] = '{"etat":"ok","message":"L\'élément du cahier de texte a été ajouté."}');
    }
    exit('{"etat":"nok","message":"L\'élément du cahier de texte n\'a pas été ajouté. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
  }
}

///////////////////////////////////////////////////////////
// Modification des types de séance des cahiers de texte //
///////////////////////////////////////////////////////////
elseif ( ( $action == 'cdt-types' ) && isset($_REQUEST['id']) && ctype_digit($id = $_REQUEST['id']) )  {
  
  // Vérification que l'identifiant est valide
  $resultat = $mysqli->query("SELECT ordre, titre, nb, cle, matiere, (SELECT COUNT(*) FROM `cdt-types` WHERE matiere = c.matiere) AS max FROM `cdt-types` AS c WHERE id = $id AND FIND_IN_SET(matiere,'${_SESSION['matieres']}')");
  if ( !$resultat->num_rows )
    exit('{"etat":"nok","message":"Identifiant du type d\'élément de cahier de texte non valide"}');
  $r = $resultat->fetch_assoc();
  $resultat->free();

  // Traitement d'une modification
  if ( isset($_REQUEST['titre']) && isset($_REQUEST['cle']) && isset($_REQUEST['deb_fin_pour']) && in_array($deb_fin_pour = intval($_REQUEST['deb_fin_pour']),array(0,1,2,3,4,5)) )  {
    $titre = mb_convert_case(strip_tags(trim($mysqli->real_escape_string($_REQUEST['titre']))),MB_CASE_TITLE);
    $cle = str_replace(' ','_',trim($mysqli->real_escape_string($_REQUEST['cle'])));
    if ( !strlen($titre) || !strlen($cle) )
      exit("{\"etat\":\"nok\",\"message\":\"Le type de séance <em>${r['titre']}</em> n'a pas été modifié. Le texte et la clé doivent être non vides.\"}");
    if ( $cle != $r['cle'] )  {
      // Vérification que la clé n'existe pas déjà
      $resultat = $mysqli->query("SELECT cle FROM `cdt-types` WHERE id != $id AND matiere = ${r['matiere']}");
      if ( $resultat->num_rows )  {
        while ( $r = $resultat->fetch_assoc() )
          if ( $r['cle'] == $cle )
            exit("{\"etat\":\"nok\",\"message\":\"Le type de séance <em>${r['titre']}</em> n'a pas été modifié. Cette clé existe déjà et doit être unique.\"}");
        $resultat->free();
      }
    }
    if ( requete('cdt-types',"UPDATE `cdt-types` SET titre = '$titre', cle = '$cle', deb_fin_pour = $deb_fin_pour WHERE id = $id",$mysqli) )
      exit($_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"Le type de séance <em>${r['titre']}</em> a été modifié.\"}");
    exit("{\"etat\":\"nok\",\"message\":\"Le type de séance <em>${r['titre']}</em> n'a pas été modifié. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
  }
  
  // Déplacement vers le haut
  if ( isset($_REQUEST['monte']) && ( $r['ordre'] > 1 ) )
    exit( ( requete('cdt-types',"UPDATE `cdt-types` SET ordre = (2*${r['ordre']}-1-ordre) WHERE ( ordre = ${r['ordre']} OR ordre = (${r['ordre']}-1) ) AND matiere = ${r['matiere']}",$mysqli)
            && $mysqli->query('ALTER TABLE `cdt-types` ORDER BY matiere,ordre') )
        ? "{\"etat\":\"ok\",\"message\":\"Le déplacement du type de séance <em>${r['titre']}</em> a été réalisé.\"}"
        : "{\"etat\":\"nok\",\"message\":\"Le type de séance <em>${r['titre']}</em> n'a pas été déplacé. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');

  // Déplacement vers le bas
  if ( isset($_REQUEST['descend']) && ( $r['ordre'] < $r['max'] ) )
    exit( ( requete('cdt-types',"UPDATE `cdt-types` SET ordre = (2*${r['ordre']}+1-ordre) WHERE ( ordre = ${r['ordre']} OR ordre = (${r['ordre']}+1) ) AND matiere = ${r['matiere']}",$mysqli)
            && $mysqli->query('ALTER TABLE `cdt-types` ORDER BY matiere,ordre') )
        ? "{\"etat\":\"ok\",\"message\":\"Le déplacement du type de séance <em>${r['titre']}</em> a été réalisé.\"}"
        : "{\"etat\":\"nok\",\"message\":\"Le type de séance <em>${r['titre']}</em> n'a pas été déplacé. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');

  // Suppression
  if ( isset($_REQUEST['supprime']) )  {
    if ( $r['max'] == 1 )
      exit("{\"etat\":\"ok\",\"message\":\"Le type de séance <em>${r['nom']}</em> n'a pas été supprimé. Il faut obligatoirement en garder au moins un.\"}");
    exit( ( requete('cdt',"DELETE FROM cdt WHERE type = $id",$mysqli) && requete('cdt-types',"DELETE FROM `cdt-types` WHERE id = $id",$mysqli)
            && requete('cdt-types',"UPDATE `cdt-types` SET ordre = (ordre-1) WHERE ordre > ${r['ordre']} AND matiere = ${r['matiere']}",$mysqli) )
        ? "{\"etat\":\"ok\",\"message\":\"Le type de séance <em>${r['titre']}</em> a été supprimé.\"}"
        : "{\"etat\":\"nok\",\"message\":\"Le type de séance <em>${r['titre']}</em> n'a pas été supprimé. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
  }
}

////////////////////////////////////////////////////
// Ajout d'un type de séance des cahiers de texte //
////////////////////////////////////////////////////
elseif ( ( $action == 'ajout-cdt-types' ) && isset($_REQUEST['titre']) && isset($_REQUEST['cle']) && isset($_REQUEST['deb_fin_pour']) && in_array($deb_fin_pour = intval($_REQUEST['deb_fin_pour']),array(0,1,2,3,4,5)) && isset($_REQUEST['matiere']) && in_array($matiere = intval($_REQUEST['matiere']),explode(',',$_SESSION['matieres'])) )  {
  $titre = mb_convert_case(strip_tags(trim($mysqli->real_escape_string($_REQUEST['titre']))),MB_CASE_TITLE);
  $cle = str_replace(' ','_',trim($mysqli->real_escape_string($_REQUEST['cle'])));
  if ( !strlen($titre) || !strlen($cle) )
    exit('{"etat":"nok","message":"Le type de séance n\'a pas été ajouté. Le texte et la clé doivent être non vides."}');
  // Vérification que la clé n'existe pas déjà
  $resultat = $mysqli->query("SELECT cle FROM `cdt-types` WHERE matiere = $matiere");
  if ( $resultat->num_rows )  {
    while ( $r = $resultat->fetch_assoc() )
      if ( $r['cle'] == $cle )
        exit('{"etat":"nok","message":"Le type de séance n\'a pas été ajouté. Cette clé existe déjà et doit être unique."}');
    $resultat->free();
  }
  // Écriture
  if ( requete('cdt-types',"INSERT INTO `cdt-types` SET matiere = $matiere, titre = '$titre', cle = '$cle', deb_fin_pour = $deb_fin_pour,
                              ordre = (SELECT max(ct.ordre)+1 FROM `cdt-types` AS ct WHERE ct.matiere = $matiere)",$mysqli) )
    exit($_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"Le type de séance <em>$titre</em> a été ajouté.\"}");
  exit("{\"etat\":\"nok\",\"message\":\"Le type de séance <em>$titre</em> n'a pas été ajouté. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
}
    
//////////////////////////////////////////////////////
// Modification des raccourcis des cahiers de texte //
//////////////////////////////////////////////////////
elseif ( ( $action == 'cdt-raccourcis' ) && isset($_REQUEST['id']) && ctype_digit($id = $_REQUEST['id']) )  {
  
  // Vérification que l'identifiant est valide
  $resultat = $mysqli->query("SELECT ordre, nom, matiere, (SELECT COUNT(*) FROM `cdt-seances` WHERE matiere = c.matiere) AS max FROM `cdt-seances` AS c WHERE id = $id AND FIND_IN_SET(matiere,'${_SESSION['matieres']}')");
  if ( !$resultat->num_rows )
    exit('{"etat":"nok","message":"Identifiant du raccourci de cahier de texte non valide"}');
  $r = $resultat->fetch_assoc();
  $resultat->free();

  // Traitement d'une modification
  if ( isset($_REQUEST['nom']) && isset($_REQUEST['type']) && ctype_digit($type = $_REQUEST['type']) && isset($_REQUEST['jour']) && in_array( $jour = intval($_REQUEST['jour']),array(1,2,3,4,5,6,7)) )  {
    if ( !strlen($nom = $mysqli->real_escape_string(trim($_REQUEST['nom']))) )
      exit("{\"etat\":\"nok\",\"message\":\"Le raccourci de séance <em>${r['nom']}</em> n'a pas été modifié. Le nom doit être non vide.\"}");
    // Validation du type de séance
    $resultat = $mysqli->query("SELECT deb_fin_pour FROM `cdt-types` WHERE id = $type AND matiere = ${r['matiere']}");
    if ( !$resultat->num_rows )
      exit("{\"etat\":\"nok\",\"message\":\"Le raccourci de séance <em>${r['nom']}</em> n'a pas été modifié. Le type de séance n'est pas valide.\"}");
    $s = $resultat->fetch_assoc();
    $resultat->free();
    // Validation des horaires
    $h_debut = $h_fin = '0:00';
    $demigroupe = 0;
    switch ( $s['deb_fin_pour'] )  {
      case 1: $h_fin = preg_filter('/(\d{1,2})h(\d{2})/','$1:$2',$_REQUEST['h_fin']);
      case 0: $h_debut = preg_filter('/(\d{1,2})h(\d{2})/','$1:$2',$_REQUEST['h_debut']);
      case 2: 
      case 3: $demigroupe = intval($_REQUEST['demigroupe'] == 1);
      // Cas 4 et 5 : h_debut, h_fin et pour restent nuls (cf l'aide)
    }
    // Écriture
    if ( requete('cdt-seances',"UPDATE `cdt-seances` SET nom = '$nom', jour = $jour, h_debut = '$h_debut',
                                h_fin = '$h_fin', type = $type, demigroupe = $demigroupe WHERE id = $id",$mysqli) )
      exit($_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"Le raccourci de séance <em>${r['nom']}</em> a été modifié.\"}");
    exit("{\"etat\":\"nok\",\"message\":\"Le raccourci de séance <em>${r['nom']}</em> n'a pas été modifié. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
  }
  
  // Déplacement vers le haut
  if ( isset($_REQUEST['monte']) && ( $r['ordre'] > 1 ) )
    exit( ( requete('cdt-seances',"UPDATE `cdt-seances` SET ordre = (2*${r['ordre']}-1-ordre) WHERE ( ordre = ${r['ordre']} OR ordre = (${r['ordre']}-1) ) AND matiere = ${r['matiere']}",$mysqli)
            && $mysqli->query('ALTER TABLE `cdt-seances` ORDER BY matiere,ordre') )
        ? "{\"etat\":\"ok\",\"message\":\"Le déplacement du raccourci de séance <em>${r['nom']}</em> a été réalisé.\"}"
        : "{\"etat\":\"nok\",\"message\":\"Le raccourci de séance <em>${r['nom']}</em> n'a pas été déplacé. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');

  // Déplacement vers le bas
  if ( isset($_REQUEST['descend']) && ( $r['ordre'] < $r['max'] ) )
    exit( ( requete('cdt-seances',"UPDATE `cdt-seances` SET ordre = (2*${r['ordre']}+1-ordre) WHERE ( ordre = ${r['ordre']} OR ordre = (${r['ordre']}+1) ) AND matiere = ${r['matiere']}",$mysqli)
            && $mysqli->query('ALTER TABLE `cdt-seances` ORDER BY matiere,ordre') )
        ? "{\"etat\":\"ok\",\"message\":\"Le déplacement du raccourci de séance <em>${r['nom']}</em> a été réalisé.\"}"
        : "{\"etat\":\"nok\",\"message\":\"Le raccourci de séance <em>${r['nom']}</em> n'a pas été déplacé. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');

  // Suppression
  if ( isset($_REQUEST['supprime']) )
    exit( ( requete('cdt-seances',"DELETE FROM `cdt-seances` WHERE id = $id",$mysqli)
            && requete('cdt-seances',"UPDATE `cdt-seances` SET ordre = (ordre-1) WHERE ordre > ${r['ordre']} AND matiere = ${r['matiere']}",$mysqli) )
        ? "{\"etat\":\"ok\",\"message\":\"Le raccourci de séance <em>${r['nom']}</em> a été supprimé.\"}"
        : "{\"etat\":\"nok\",\"message\":\"Le raccourci de séance <em>${r['nom']}</em> n'a pas été supprimé. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
}

///////////////////////////////////////////////
// Ajout d'un raccourci des cahiers de texte //
///////////////////////////////////////////////
elseif ( ( $action == 'ajout-cdt-raccourci' ) && isset($_REQUEST['nom']) && isset($_REQUEST['type']) && ctype_digit($type = $_REQUEST['type']) && isset($_REQUEST['jour']) && in_array( $jour = intval($_REQUEST['jour']),array(1,2,3,4,5,6,7)) && isset($_REQUEST['matiere']) && in_array($matiere = intval($_REQUEST['matiere']),explode(',',$_SESSION['matieres'])) )  {
  if ( !strlen($nom = $mysqli->real_escape_string(trim($_REQUEST['nom']))) )
    exit('{"etat":"nok","message":"Le raccourci de séance n\'a pas été ajouté. Le nom doit être non vide."}');
  // Validation du type de séance
  $resultat = $mysqli->query("SELECT id, deb_fin_pour FROM `cdt-types` WHERE id = $type AND matiere = $matiere");
  if ( !$resultat->num_rows )
    exit('{"etat":"nok","message":"Le raccourci de séance n\'a pas été ajouté. Le type de séance n\'est pas valide."}');
  $r = $resultat->fetch_assoc();
  $resultat->free();
  // Validation des horaires
  $h_debut = $h_fin = '0:00';
  $demigroupe = 0;
  switch ( $r['deb_fin_pour'] )  {
    case 1: $h_fin = preg_filter('/(\d{1,2})h(\d{2})/','$1:$2',$_REQUEST['h_fin']);
    case 0: $h_debut = preg_filter('/(\d{1,2})h(\d{2})/','$1:$2',$_REQUEST['h_debut']);
    case 2: 
    case 3: $demigroupe = intval($_REQUEST['demigroupe'] == 1);
    // Cas 4 et 5 : h_debut, h_fin et pour restent nuls (cf l'aide)
  }
  // Écriture
  if ( requete('cdt-seances',"INSERT INTO `cdt-seances` SET matiere = $matiere, nom = '$nom', jour = $jour,
                              ordre = (SELECT IFNULL(max(cs.ordre)+1,1) FROM `cdt-seances` AS cs WHERE cs.matiere = $matiere),
                              h_debut = '$h_debut', h_fin = '$h_fin', type = $type, demigroupe = $demigroupe",$mysqli) )
    exit($_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"Le raccourci de séance <em>$nom</em> a été ajouté.\"}");
  exit('{"etat":"nok","message":"Le raccourci de séance n\'a pas été ajouté. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
}

////////////////////////////
// Modification des pages //
////////////////////////////
elseif ( ( $action == 'pages' ) && isset($_REQUEST['id']) && ctype_digit($id = $_REQUEST['id']) )  {

  // Vérification que l'identifiant est valide
  $resultat = $mysqli->query("SELECT ordre, mat, nom, cle, (SELECT COUNT(*) FROM pages WHERE mat = p.mat) AS max FROM pages AS p WHERE id = $id AND FIND_IN_SET(mat,'${_SESSION['matieres']}')");
  if ( !$resultat->num_rows )
    exit('{"etat":"nok","message":"Identifiant de page non valide"}');
  $r = $resultat->fetch_assoc();
  $resultat->free();

  // Traitement d'une modification globale (depuis index.php ou pages.php)
  if ( isset($_REQUEST['titre']) && isset($_REQUEST['nom']) && isset($_REQUEST['cle']) && isset($_REQUEST['bandeau']) && isset($_REQUEST['protection']) )  {
    $titre = strip_tags(trim($mysqli->real_escape_string($_REQUEST['titre'])));
    $nom = strip_tags(trim($mysqli->real_escape_string($_REQUEST['nom'])));
    $titre = mb_strtoupper(mb_substr($titre,0,1)).mb_substr($titre,1);
    $nom = mb_strtoupper(mb_substr($nom,0,1)).mb_substr($nom,1);
    $cle = str_replace(' ','_',strip_tags(trim($mysqli->real_escape_string($_REQUEST['cle']))));
    if ( !strlen($_REQUEST['titre']) || !strlen($_REQUEST['nom']) || !strlen($_REQUEST['cle']) )
      exit("{\"etat\":\"nok\",\"message\":\"La page <em>${r['nom']}</em> n'a pas été modifiée. Le titre, le nom et la clé doivent être non vides.\"}");
    // Partie de requête si modification de matière
    // N'existe qu'en provenance de pages.php (et non d'index.php)
    $requete_matiere = ( isset($_REQUEST['matiere']) && in_array($matiere = intval($_REQUEST['matiere']),explode(',',$_SESSION['matieres'])) && ( $matiere != $r['mat'] ) && ( $id > 1 ) ) ? ", mat = $matiere" : '';
    // Vérification que la clé n'existe pas déjà
    $requete_cle = '';
    if ( $cle != $r['cle'] )  {
      $resultat = $mysqli->query('SELECT cle FROM pages WHERE mat = '.( strlen($requete_matiere) ? $matiere : $r['mat'] ));
      if ( $resultat->num_rows )  {
        while ( $s = $resultat->fetch_row() )
          if ( $s[0] == $cle )
            exit("{\"etat\":\"nok\",\"message\":\"La page <em>${r['nom']}</em> n'a pas été modifiée. La clé donnée existe déjà. Elle doit être différente de celles des autres pages.\"}"); 
        $resultat->free();
      $requete_cle = "cle = '$cle',";
      }
    }
    $bandeau = trim($mysqli->real_escape_string($_REQUEST['bandeau']));
    // Génération de la valeur de protection
    $val = array_filter($_REQUEST['protection'],function($id) { return ctype_digit($id); });
    if ( !count($val) )
      exit("{\"etat\":\"nok\",\"message\":\"La page <em>${r['nom']}</em> n'a pas été modifiée. La protection d'accès est incorrecte.\"}");
    if ( ( $val[0] == 0 ) || ( $val[0] == 32 ) )
      $protection = $val[0];
    else  {
      $protection = 32;
      foreach (array_slice($val,1) as $v) 
        $protection = $protection-2**($v-1);
    }
    // Écriture
    if ( requete('pages',"UPDATE pages SET titre = '$titre', nom = '$nom', $requete_cle bandeau = '$bandeau', protection = $protection $requete_matiere WHERE id = $id",$mysqli) )  {
      if ( strlen($requete_matiere) )  {
        requete('pages',"UPDATE pages SET ordre = (SELECT COUNT(*) FROM (SELECT id FROM pages AS p WHERE p.mat = $matiere) AS p1) WHERE id = $id",$mysqli);
        requete('pages',"UPDATE pages SET ordre = (ordre-1) WHERE mat = ${r['mat']} AND ordre > ${r['ordre']}",$mysqli);
        $mysqli->query('ALTER TABLE pages ORDER BY mat,ordre');
      }
      if ( isset($_REQUEST['propagation']) )  {
        requete('infos',"UPDATE infos SET protection = $protection WHERE page = $id",$mysqli);
        // Mise à jour des informations récentes
        requete('recents',"UPDATE recents SET protection = $protection WHERE id IN (SELECT 1000+infos.id FROM infos WHERE page = $id)",$mysqli);
        rss($mysqli, ( $r['mat'] == 0 ) ? array(0) : array(0,$r['mat']) );
      }
      exit($_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"La page <em>${r['nom']}</em> a été modifiée.\"}");
    }
    else
      exit("{\"etat\":\"nok\",\"message\":\"La page <em>${r['nom']}</em> n'a pas été modifiée. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
  }

  // Déplacement vers le haut
  if ( isset($_REQUEST['monte']) && ( $r['ordre'] > 1+!$r['mat'] ) )
    exit( ( requete('pages',"UPDATE pages SET ordre = (2*${r['ordre']}-1-ordre) WHERE mat = ${r['mat']} AND ( ordre = ${r['ordre']} OR ordre = (${r['ordre']}-1) )",$mysqli) 
            && $mysqli->query('ALTER TABLE pages ORDER BY mat,ordre') )
        ? "{\"etat\":\"ok\",\"message\":\"Le déplacement de la page <em>${r['nom']}</em> a été réalisé.\"}"
        : "{\"etat\":\"nok\",\"message\":\"La page <em>${r['nom']}</em> n'a pas été déplacée. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');

  // Déplacement vers le bas
  if ( isset($_REQUEST['descend']) && ( $r['ordre'] < $r['max'] ) && ( $id > 1 ) )
    exit( ( requete('pages',"UPDATE pages SET ordre = (2*${r['ordre']}+1-ordre) WHERE mat = ${r['mat']} AND ( ordre = ${r['ordre']} OR ordre = (${r['ordre']}+1) )",$mysqli) 
            && $mysqli->query('ALTER TABLE pages ORDER BY mat,ordre') )
        ? "{\"etat\":\"ok\",\"message\":\"Le déplacement de la page <em>${r['nom']}</em> a été réalisé.\"}"
        : "{\"etat\":\"nok\",\"message\":\"La page <em>${r['nom']}</em> n'a pas été déplacée. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');

  // Suppression
  if ( isset($_REQUEST['supprime']) )  {
    if ( $id == 1 )
      exit("{\"etat\":\"nok\",\"message\":\"La page <em>${r['nom']}</em> ne peut pas être supprimée.\"}");
    if ( requete('pages',"DELETE FROM pages WHERE id = $id",$mysqli)
      && requete('infos',"DELETE FROM infos WHERE page = $id",$mysqli)
      && requete('pages',"UPDATE pages SET ordre = (ordre-1) WHERE mat = ${r['mat']} AND ordre > ${r['ordre']}",$mysqli) 
      && $mysqli->query('ALTER TABLE pages ORDER BY mat,ordre') )
      exit("{\"etat\":\"ok\",\"message\":\"La page <em>${r['nom']}</em> a été supprimée. Les informations contenues ont été supprimées.'\"}");
    exit("{\"etat\":\"nok\",\"message\":\"La page <em>${r['nom']}</em> n'a pas été supprimée. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
  }

  // Suppression des informations
  if ( isset($_REQUEST['supprime_infos']) )
    exit( ( requete('infos',"DELETE FROM infos WHERE pages = $id",$mysqli) )
      ? "{\"etat\":\"ok\",\"message\":\"Les informations de la page <em>${r['nom']}</em> ont été supprimées.\"}"
      : "{\"etat\":\"nok\",\"message\":\"Les informations de la page <em>${r['nom']}</em> n'ont pas été supprimées. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
}
   
//////////////////////
// Ajout d'une page //
//////////////////////
elseif ( ( $action == 'ajout-page' ) && isset($_REQUEST['titre']) && isset($_REQUEST['nom']) && isset($_REQUEST['cle']) && isset($_REQUEST['bandeau']) && isset($_REQUEST['matiere']) && isset($_REQUEST['protection']) && in_array($matiere = intval($_REQUEST['matiere']),explode(',',$_SESSION['matieres'])) )  {
  $titre = strip_tags(trim($mysqli->real_escape_string($_REQUEST['titre'])));
  $nom = strip_tags(trim($mysqli->real_escape_string($_REQUEST['nom'])));
  $titre = mb_strtoupper(mb_substr($titre,0,1)).mb_substr($titre,1);
  $nom = mb_strtoupper(mb_substr($nom,0,1)).mb_substr($nom,1);
  $cle = str_replace(' ','_',strip_tags(trim($mysqli->real_escape_string($_REQUEST['cle']))));
  if ( !strlen($_REQUEST['titre']) || !strlen($_REQUEST['nom']) || !strlen($_REQUEST['cle']) )
    exit('{"etat":"nok","message":"La page n\'a pas été ajoutée. Le titre, le nom et la clé doivent être non vides."}');
  // Vérification que la clé n'existe pas déjà
  $resultat = $mysqli->query("SELECT cle FROM pages WHERE mat = $matiere");
  if ( $resultat->num_rows )  {
    while ( $r = $resultat->fetch_row() )
      if ( $r[0] == $cle )
        exit("{\"etat\":\"nok\",\"message\":\"La page <em>$nom</em> n'a pas été ajoutée. La clé donnée existe déjà. Elle doit être différente de celles des autres pages.\"}");
    $resultat->free();
  }
  $bandeau = trim($mysqli->real_escape_string($_REQUEST['bandeau']));
  // Génération de la valeur de protection
  $val = array_filter($_REQUEST['protection'],function($id) { return ctype_digit($id); });
  if ( !count($val) )
    exit("{\"etat\":\"nok\",\"message\":\"La page <em>$nom</em> n'a pas été ajoutée. La protection d'accès est incorrecte.\"}");
  if ( ( $val[0] == 0 ) || ( $val[0] == 32 ) )
    $protection = $val[0];
  else  {
    $protection = 32;
    foreach (array_slice($val,1) as $v) 
      $protection = $protection-2**($v-1);
  }
  // Écriture
  if ( requete('pages',"INSERT INTO pages SET titre = '$titre', nom = '$nom', cle = '$cle', mat = $matiere, bandeau = '$bandeau', protection = $protection, ordre = (SELECT IFNULL(MAX(ordre)+1,1) FROM pages AS p WHERE p.mat = $matiere)",$mysqli) )
    exit("{\"etat\":\"ok\",\"message\":\"La page <em>$nom</em> a été ajoutée.\"}");
  exit("{\"etat\":\"nok\",\"message\":\"La page <em>$nom</em> n'a pas été ajoutée. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
}

///////////////////////////////
// Modification des matières //
///////////////////////////////
elseif ( ( $action == 'matieres' ) && isset($_REQUEST['id']) && ctype_digit($id = $_REQUEST['id']) )  {

  // Déplacements (possibles pour toute matière, contrairement au reste)
  if ( isset($_REQUEST['monte']) || isset($_REQUEST['descend']) )  {
    $resultat = $mysqli->query("SELECT ordre, nom, (SELECT COUNT(*) FROM matieres) AS max FROM matieres WHERE id = $id");
    if ( !$resultat->num_rows )
      exit('{"etat":"nok","message":"Identifiant de matière non valide"}');
    $r = $resultat->fetch_assoc();
    $resultat->free();
    
    // Déplacement vers le haut
    if ( isset($_REQUEST['monte']) && ( $r['ordre'] > 1 ) )
      exit( ( requete('matieres',"UPDATE matieres SET ordre = (2*${r['ordre']}-1-ordre) WHERE ( ordre = ${r['ordre']} OR ordre = (${r['ordre']}-1) )",$mysqli) && $mysqli->query('ALTER TABLE matieres ORDER BY ordre') )
        ? "{\"etat\":\"ok\",\"message\":\"Le déplacement de la matière <em>${r['nom']}</em> a été réalisé.\"}"
        : "{\"etat\":\"nok\",\"message\":\"La matière <em>${r['nom']}</em> n'a pas été déplacée. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');

    // Déplacement vers le bas
    if ( isset($_REQUEST['descend']) && ( $r['ordre'] < $r['max'] ) )
      exit( ( requete('matieres',"UPDATE matieres SET ordre = (2*${r['ordre']}+1-ordre) WHERE ( ordre = ${r['ordre']} OR ordre = (${r['ordre']}+1) )",$mysqli) && $mysqli->query('ALTER TABLE matieres ORDER BY ordre') )
        ? "{\"etat\":\"ok\",\"message\":\"Le déplacement de la matière <em>${r['nom']}</em> a été réalisé.\"}"
        : "{\"etat\":\"nok\",\"message\":\"La matière <em>${r['nom']}</em> n'a pas été déplacée. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
  }

  // Vérification que l'identifiant est valide
  elseif ( !in_array($id,explode(',',$_SESSION['matieres'])) )
    exit('{"etat":"nok","message":"Identifiant de matière non valide"}');
  
  $resultat = $mysqli->query("SELECT ordre, cle, nom, colles_protection, cdt_protection, docs_protection, (SELECT COUNT(*) FROM matieres) AS max FROM matieres WHERE id = $id");
  $r = $resultat->fetch_assoc();
  $resultat->free();

  // Traitement d'une modification
  if ( isset($_REQUEST['nom']) && isset($_REQUEST['cle']) && isset($_REQUEST['colles_protection']) && isset($_REQUEST['cdt_protection']) && isset($_REQUEST['docs_protection']) && isset($_REQUEST['notes']) && isset($_REQUEST['dureecolle']) )  {
    $nom = strip_tags(trim($mysqli->real_escape_string($_REQUEST['nom'])));
    $nom = mb_strtoupper(mb_substr($nom,0,1)).mb_substr($nom,1);
    $cle = str_replace(' ','_',strip_tags(trim($mysqli->real_escape_string($_REQUEST['cle']))));
    if ( !strlen($nom) || !strlen($cle) )
      exit("{\"etat\":\"nok\",\"message\":\"La matière <em>${r['nom']}</em> n'a pas été modifiée. Le nom et la clé doivent être non vides.\"}");
    // Vérification que la clé n'existe pas déjà
    if ( $cle != $r['cle'] )  {
      $resultat = $mysqli->query('SELECT cle FROM matieres');
      if ( $resultat->num_rows )  {
        while ( $s = $resultat->fetch_row() )
          if ( $s[0] == $cle )
            exit("{\"etat\":\"nok\",\"message\":\"La matière <em>${r['nom']}</em> n'a pas été modifiée. La clé donnée existe déjà. Elle doit être différente de celles des autres matières.\"}");
        $resultat->free();
      }
    }
    // Génération des valeurs de protection
    $protection = array();
    foreach ( array('colles','cdt','docs') as $fonction )  {
      $val = array_filter($_REQUEST[$fonction.'_protection'],function($id) { return ctype_digit($id); });
      if ( !count($val) )
        exit("{\"etat\":\"nok\",\"message\":\"La matière <em>${r['nom']}</em> n'a pas été modifiée. Une des protections d'accès est incorrecte.\"}");
      if ( ( $val[0] == 0 ) || ( $val[0] == 32 ) )
        $protection[$fonction] = $val[0];
      else  {
        $p = 32;
        foreach (array_slice($val,1) as $v) 
          $p = $p-2**($v-1);
        $protection[$fonction] = $p;
      }
    }
    // Affichage des notes : 2-> désactivée ; 1-> possible (0 ou 1 dans la base)
    $notes = ( $_REQUEST['notes'] == 2 ) ? '2' : "IF( notes=2, IF((SELECT id FROM notes WHERE matiere = $id LIMIT 1),1,0), notes)";
    $dureecolle = intval($_REQUEST['dureecolle']) ?: 20;
    // Écriture
    if ( requete('matieres',"UPDATE matieres SET nom = '$nom', cle = '$cle', notes = $notes, colles_protection = ${protection['colles']}, cdt_protection = ${protection['cdt']}, docs_protection = ${protection['docs']}, dureecolle = $dureecolle WHERE id = $id",$mysqli) )  {
      if ( $nom != $r['nom'] )
        requete('reps',"UPDATE reps SET nom = '$nom' WHERE matiere = $id AND parent = 0",$mysqli);
      if ( $protection['docs'] != $r['docs_protection'] )
        requete('reps',"UPDATE reps SET protection = ${protection['docs']} WHERE matiere = $id AND parent = 0",$mysqli);
      exit($_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"La matière <em>${r['nom']}</em> a été modifiée.\"}");
    }
    else
      exit("{\"etat\":\"nok\",\"message\":\"La matière <em>${r['nom']}</em> n'a pas été modifiée. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
  }
  
  // Suppression
  if ( isset($_REQUEST['supprime']) )  {
    if ( $r['max'] == 1 )
      exit("{\"etat\":\"nok\",\"message\":\"La matière <em>${r['nom']}</em> n'a pas été supprimée. Il faut obligatoirement en garder au moins une.\"}");
    if ( requete('matieres',"DELETE FROM matieres WHERE id = $id",$mysqli) 
      && requete('matieres',"UPDATE matieres SET ordre = (ordre-1) WHERE ordre > ${r['ordre']}",$mysqli)
      && requete('colles',"DELETE FROM colles WHERE matiere = $id",$mysqli)
      && requete('cdt',"DELETE FROM cdt WHERE matiere = $id",$mysqli)
      && requete('cdt-types',"DELETE FROM `cdt-types` WHERE matiere = $id",$mysqli)
      && requete('cdt-seances',"DELETE FROM `cdt-seances` WHERE matiere = $id",$mysqli)
      && requete('notes',"DELETE FROM notes WHERE matiere = $id",$mysqli)
      && requete('reps',"UPDATE reps SET matiere = 0 WHERE matiere = $id",$mysqli)
      && requete('docs',"UPDATE docs SET matiere = 0 WHERE matiere = $id",$mysqli)
      && requete('pages',"UPDATE pages SET mat = 0 WHERE mat = $id",$mysqli)
      && requete('agenda',"UPDATE agenda SET matiere = 0 WHERE matiere = $id",$mysqli)
      && requete('utilisateurs',"UPDATE utilisateurs SET matieres = TRIM(TRAILING ',' FROM REPLACE(CONCAT(matieres,','),',$id,',',')) ",$mysqli) )
      exit("{\"etat\":\"ok\",\"message\":\"La matière <em>${r['nom']}</em> a été supprimée. Les répertoires, documents, pages d'informations et éléments d'agenda associés à la matières n'ont pas été supprimés mais déplacés dans le contexte «&nbsp;général&nbsp;»'\"}");
    exit("{\"etat\":\"nok\",\"message\":\"La matière <em>${r['nom']}</em> n'a pas été supprimée. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
  }

  // Suppression des programmes de colles d'une matière
  if ( isset($_REQUEST['supprime_colles']) )
    exit( ( requete('colles',"DELETE FROM colles WHERE matiere = $id",$mysqli) && requete('matieres',"UPDATE matieres SET colles = 0 WHERE id = $id",$mysqli) )
      ? "{\"etat\":\"ok\",\"message\":\"Les programmes de colle de la matière <em>${r['nom']}</em> ont été supprimés.\"}"
      : "{\"etat\":\"nok\",\"message\":\"Les programmes de colle de la matière <em>${r['nom']}</em> n'ont pas été supprimés. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
  
  // Suppression du cahier de texte d'une matière
  if ( isset($_REQUEST['supprime_cdt']) )
    exit( ( requete('cdt',"DELETE FROM cdt WHERE matiere = $id",$mysqli) && requete('matieres',"UPDATE matieres SET cdt = 0 WHERE id = $id",$mysqli) )
      ? "{\"etat\":\"ok\",\"message\":\"Le cahier de texte de la matière <em>${r['nom']}</em> a été supprimé.\"}"
      : "{\"etat\":\"nok\",\"message\":\"Le cahier de texte de la matière <em>${r['nom']}</em> n'a pas été supprimé. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');

  // Suppression des notes d'une matière
  if ( isset($_REQUEST['supprime_notes']) )
    exit( ( requete('notes',"DELETE FROM notes WHERE matiere = $id",$mysqli) && requete('matieres',"UPDATE matieres SET notes = 0 WHERE id = $id",$mysqli) )
      ? "{\"etat\":\"ok\",\"message\":\"Les notes de la matière <em>${r['nom']}</em> ont été supprimées.\"}"
      : "{\"etat\":\"nok\",\"message\":\"Les notes de la matière <em>${r['nom']}</em> n'ont pas été supprimées. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');

  // Suppression des documents d'une matière
  if ( isset($_REQUEST['supprime_docs']) )  {
    if ( requete('reps',"DELETE FROM reps WHERE matiere = $id AND parent > 0",$mysqli) )  {
      // Suppression physique
      $resultat = $mysqli->query("SELECT lien FROM docs WHERE matiere = $id");
      if ( $resultat->num_rows )  {
        while ( $r = $resultat->fetch_row() )
          exec("rm -rf documents/${r[0]}");
        $resultat->free();
        requete('docs',"DELETE FROM docs WHERE matiere = $id",$mysqli);
      }
      requete('matieres',"UPDATE matieres SET docs = 0 WHERE id = $id",$mysqli);
      exit("{\"etat\":\"ok\",\"message\":\"Les répertoires et documents de la matière <em>${r['nom']}</em> ont été supprimés.\"}");
    }
    exit("{\"etat\":\"nok\",\"message\":\"Les documents de la matière <em>${r['nom']}</em> n'ont pas été supprimés. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
  }
}
  
/////////////////////////
// Ajout d'une matière //
/////////////////////////
elseif ( ( $action == 'ajout-matiere' ) && isset($_REQUEST['nom']) && isset($_REQUEST['cle']) && isset($_REQUEST['colles_protection']) && isset($_REQUEST['cdt_protection']) && isset($_REQUEST['docs_protection']) && isset($_REQUEST['notes']) && isset($_REQUEST['dureecolle']) )  {
  $nom = strip_tags(trim($mysqli->real_escape_string($_REQUEST['nom'])));
  $nom = mb_strtoupper(mb_substr($nom,0,1)).mb_substr($nom,1);
  $cle = str_replace(' ','_',strip_tags(trim($mysqli->real_escape_string($_REQUEST['cle']))));
  if ( !strlen($nom) || !strlen($cle) )
    exit('{"etat":"nok","message":"La matière n\'a pas été ajoutée. Le nom et la clé doivent être non vides."}');
  // Vérification que la clé n'existe pas déjà
  $resultat = $mysqli->query('SELECT cle FROM matieres');
  while ( $r = $resultat->fetch_row() )
    if ( $r[0] == $cle )
      exit("{\"etat\":\"nok\",\"message\":\"La matière <em>$nom</em> n'a pas été ajoutée. La clé donnée existe déjà. Elle doit être différente de celles des autres matières.\"}");
  $resultat->free();
  // Génération des valeurs de protection
  $protection = array();
  foreach ( array('colles','cdt','docs') as $fonction )  {
    $val = array_filter($_REQUEST[$fonction.'_protection'],function($id) { return ctype_digit($id); });
    if ( !count($val) )
      exit("{\"etat\":\"nok\",\"message\":\"La matière <em>$nom</em> n'a pas été ajoutée. Une des protections d'accès est incorrecte.\"}");
    if ( ( $val[0] == 0 ) || ( $val[0] == 32 ) )
      $protection[$fonction] = $val[0];
    else  {
      $p = 32;
      foreach (array_slice($val,1) as $v) 
        $p = $p-2**($v-1);
      $protection[$fonction] = $p;
    }
  }
  // Affichage des notes : 2-> désactivée ; 1-> possible (0 pour l'instant dans la base)
  $notes = ( $_REQUEST['notes'] == 2 ) ? '2' : '0';
  $dureecolle = intval($_REQUEST['dureecolle']) ?: 20;
  // Écriture
  if ( requete('matieres',"INSERT INTO matieres SET nom = '$nom', cle = '$cle', notes = $notes, colles_protection = ${protection['colles']}, cdt_protection = ${protection['cdt']}, docs_protection = ${protection['docs']}, dureecolle = $dureecolle, ordre = (SELECT MAX(ordre)+1 FROM matieres AS m)",$mysqli) )  {
    $id = $mysqli->insert_id;
    requete('reps',"INSERT INTO reps SET parent = 0, parents = '0', nom = '$nom', matiere = $id",$mysqli);
    requete('cdt-types',"INSERT INTO `cdt-types` (matiere, ordre, cle, titre, deb_fin_pour) VALUES
                         ($id, 1, 'cours', 'Cours', 1),
                         ($id, 2, 'TD', 'Séance de travaux dirigés', 1),
                         ($id, 3, 'TP', 'Séance de travaux pratiques', 1),
                         ($id, 4, 'DS', 'Devoir surveillé', 1),
                         ($id, 5, 'interros', 'Interrogation de cours', 0),
                         ($id, 6, 'distributions', 'Distribution de document', 0),
                         ($id, 7, 'DM', 'Devoir maison', 2)",$mysqli);
    exit("{\"etat\":\"ok\",\"message\":\"La matière <em>$nom</em> a été ajoutée.\"}");
  }
  exit("{\"etat\":\"nok\",\"message\":\"La matière <em>$nom</em> n'a pas été ajoutée. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
}

//////////////////////////////////////////
// Modification d'un utilisateur unique //
//////////////////////////////////////////
elseif ( ( $action == 'utilisateur' ) && isset($_REQUEST['modif']) && in_array($modif = $_REQUEST['modif'],array('mailenvoi','prefs','desactive','active','supprutilisateur','validutilisateur')) && isset($_REQUEST['id']) && ctype_digit($id = $_REQUEST['id']) )  {

  // Vérification que l'identifiant est valide
  // Attention, les valeurs "valide", "demande" et "invitation" sont des chaines de caractères égales à '0' ou '1'.
  $resultat = $mysqli->query("SELECT nom, prenom, login, matieres, mail, (LENGTH(mdp)=40) AS valide, (LEFT(mdp,1)='*') AS demande, (LENGTH(mdp)=1) AS invitation, autorisation, mailenvoi, mailexp, mailliste, mailcopie FROM utilisateurs WHERE id = $id");
  if ( !$resultat->num_rows )
    exit('{"etat":"nok","message":"Identifiant non valide"}');  
  $r = $resultat->fetch_assoc();
  $resultat->free();
  $compte = ( strlen($r['nom'].$r['prenom']) ) ? "de <em>${r['prenom']} ${r['nom']}</em>" : "<em>${r['login']}</em>";
  switch ( $modif )  {

    // Modification de la possibilité d'envoyer des mails seulement
    case 'mailenvoi': {
      $val = intval( isset($_REQUEST['val']) && $_REQUEST['val'] );
      if ( $r['autorisation'] == 1 )
        exit('{"etat":"nok","message":"Un compte de type invité ne peut pas envoyer des courriels."}');
      if ( $val == $r['mailenvoi'] )
        exit('{"etat":"ok","message":"Ce réglage était déjà celui en place. Aucune modification n\'a été effectuée."}');
      if ( $val && !strlen($r['mail']) )
        exit('{"etat":"nok","message":"Un compte ne peut envoyer de courriel sans adresse électronique valide."}');
      if ( requete('utilisateurs',"UPDATE utilisateurs SET mailenvoi = $val, mailexp = IF($val AND mailexp = '',CONCAT(prenom,' ',nom),mailexp) WHERE id = $id",$mysqli) )
        exit('{"etat":"ok","message":"Les préférences d\'envoi de mail '.$compte.' ont été modifiées."}');
      exit('{"etat":"nok","message":"Les préférences d\'envoi de mail '.$compte.' n\'ont pas été modifiées. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
    }

    // Modification des données du compte (venant du formulaire de utilisateurs.php)
    case 'prefs': {
      $modifications = array_diff_assoc( array( 'nom'=>trim($_REQUEST['nom']), 'prenom'=>trim($_REQUEST['prenom']), 'login'=>trim($_REQUEST['login']), 'mail'=>mb_strtolower(trim($_REQUEST['mail1'])), 'mailexp'=>trim(isset($_REQUEST['mailexp']) ? isset($_REQUEST['mailexp']) : ''), 'mailenvoi'=>intval(isset($_REQUEST['mailenvoi'])), 'mailcopie'=>intval(isset($_REQUEST['mailcopie'])), 'mailliste'=>intval(isset($_REQUEST['mailliste'])) ), $r);
      if ( !$modifications )
        exit('{"etat":"ok","message":"Les valeurs fournies étaient celles déjà enregistrées. Aucune modification n\'a été effectuée."}');
      $requete = '';
      if ( isset($modifications['nom']) && strlen($nom = mb_convert_case(strip_tags($mysqli->real_escape_string($modifications['nom'])),MB_CASE_TITLE)) )
        $requete .= ", nom = '$nom'";
      if ( isset($modifications['prenom']) && strlen($prenom = mb_convert_case(strip_tags($mysqli->real_escape_string($modifications['prenom'])),MB_CASE_TITLE)) )
        $requete .= ", prenom = '$prenom'";
      if ( isset($modifications['login']) && strlen($login = mb_strtolower(str_replace(' ','_',$modifications['login']))) )  {
        // Vérification que le login n'existe pas déjà
        $resultat = $mysqli->query("SELECT GROUP_CONCAT(login) FROM utilisateurs WHERE id != $id");
        $s = $resultat->fetch_row();
        $resultat->free();
        if ( !in_array($login,explode(',',$s[0])) )
          $requete .= ', login = \''.$mysqli->real_escape_string($login).'\'';
      }
      if ( isset($modifications['mail']) && filter_var($mail = $modifications['mail'],FILTER_VALIDATE_EMAIL) && isset($_REQUEST['mail2']) )  {
        if ( $mail != mb_strtolower(trim($_REQUEST['mail2'])) )
          exit('{"etat":"nok","message":"Les préférences '.$compte.' n\'ont pas été modifiées, les deux adresses électroniques saisies ne sont pas identiques."}');
        // Vérification que l'adresse n'existe pas déjà
        $resultat = $mysqli->query("SELECT GROUP_CONCAT(mail) FROM utilisateurs WHERE id != $id AND mail > ''");
        $s = $resultat->fetch_row();
        $resultat->free();
        if ( !in_array($mail,explode(',',$s[0])) )
          $requete .= ', mail = \''.$mysqli->real_escape_string($r['mail'] = $mail).'\'';
      }
      if ( isset($modifications['mailenvoi']) && ( $r['autorisation'] > 1 ) && ( !$modifications['mailenvoi'] || strlen($r['mail']) ) )
        $requete .= ', mailenvoi = \''.( $r['mailenvoi'] = $modifications['mailenvoi'] ).'\'';
      if ( $r['mailenvoi'] )  {
        if ( isset($modifications['mailexp']) && strlen($mailexp = strip_tags($mysqli->real_escape_string($modifications['mailexp']))) )
          $requete .= ", mailexp = '$mailexp'";
        elseif ( !strlen($r['mailexp']) )
          $requete .= ', mailexp = CONCAT(prenom,\' \',nom)';
        if ( isset($modifications['mailcopie']) )
          $requete .= ", mailcopie = ${modifications['mailcopie']}";
        if ( isset($modifications['mailliste']) && ( $r['autorisation'] > 2 ) )
          $requete .= ", mailliste = ${modifications['mailliste']}";
      }
      if ( !strlen($requete) )
        exit('{"etat":"nok","message":"Les préférences '.$compte.' n\'ont pas été modifiées, les valeurs saisies sont identiques à celles existantes."}');
      if( requete('utilisateurs','UPDATE utilisateurs SET '.substr($requete,2)." WHERE id = $id",$mysqli) )
        exit($_SESSION['message'] = '{"etat":"ok","message":"Les préférences '.$compte.' ont été modifiées."}');
      exit('{"etat":"nok","message":"Les préférences '.$compte.' n\'ont pas été modifiées. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
    }

    // Désactivation
    case 'desactive': {
      if ( ( $r['valide'] == 0 ) && ( $r['demande'] == 0 ) && ( $r['invitation'] == 0 ) )
        exit($_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"Le compte $compte est déjà actuellement désactivé.\"}");
      if ( ( $r['demande'] == 1 ) || ( $r['invitation'] == 1 ) )
        exit($_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"Le compte $compte n'est pas actuellement désactivable.\"}");
      if ( requete('utilisateurs',"UPDATE utilisateurs SET mdp = CONCAT('!',mdp) WHERE id = $id",$mysqli) )
        exit($_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"Compte $compte désactivé\"}");
      exit("{\"etat\":\"nok\",\"message\":\"La désactivation du compte $compte n'a pas été réalisée. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
    }

    // Réactivation
    case 'active': {
      if ( $r['valide'] == 1 )
        exit($_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"Le compte $compte est déjà actuellement activé.\"}");
      if ( ( $r['demande'] == 1 ) || ( $r['invitation'] == 1 ) )
        exit($_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"Le compte $compte n'est pas actuellement activable.\"}");
      if ( requete('utilisateurs',"UPDATE utilisateurs SET mdp = SUBSTR(mdp,2) WHERE id = $id",$mysqli) )
        exit($_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"Compte $compte réactivé\"}");
      exit("{\"etat\":\"nok\",\"message\":\"La réactivation du compte $compte n'a pas été réalisée. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
    }

    // Suppression
    case 'supprutilisateur': {
      if ( requete('utilisateurs',"DELETE FROM utilisateurs WHERE id = $id",$mysqli)
        && requete('groupes',"UPDATE groupes SET utilisateurs = TRIM(BOTH ',' FROM REPLACE(CONCAT(',',utilisateurs,','),',$id,',',')) WHERE FIND_IN_SET($id,utilisateurs)",$mysqli) )  {
        // Recherche des notes : cas des colleurs/profs
        if ( $r['autorisation'] > 2 )  {
          requete('notes',"DELETE FROM notes WHERE colleur = $id",$mysqli);
          requete('heurescolles',"DELETE FROM heurescolles WHERE colleur = $id",$mysqli);
        }
        // Recherche des notes : cas des élèves
        elseif ( $r['autorisation'] == 2 )  {
          $resultat = $mysqli->query("SELECT GROUP_CONCAT(heure) FROM notes WHERE eleve = $id");
          $s = $resultat->fetch_row();
          $resultat->free();
          if ( !is_null($s[0]) )  {
            requete('notes',"DELETE FROM notes WHERE eleve = $id",$mysqli);
            requete('heurescolles',"DELETE heurescolles FROM heurescolles LEFT JOIN notes ON heurescolles.id=notes.heure
                                    WHERE FIND_IN_SET(heurescolles.id,'${s[0]}') AND notes.id IS NULL",$mysqli);
            requete('heurescolles',"UPDATE heurescolles SET duree = duree-(SELECT dureecolle FROM matieres WHERE matieres.id = heurescolles.matiere) 
                                    WHERE FIND_IN_SET(heurescolles.id,'${s[0]}') AND releve = 0",$mysqli);
          }
        }
        exit($_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"Compte $compte supprimé\"}");
      }
      exit("{\"etat\":\"nok\",\"message\":\"La suppression du compte $compte n'a pas été réalisée. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
    }

    // Validation d'une demande
    case 'validutilisateur': {
      if ( $r['demande'] == 0 )
        exit($_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"La demande $compte a déjà été validée.\"}");
      if ( requete('utilisateurs',"UPDATE utilisateurs SET mdp = SUBSTR(mdp,2) WHERE id = $id",$mysqli) )  {
        mail($r['mail'],'=?UTF-8?B?'.base64_encode('[Cahier de Prépa] Compte validé').'?=',
"Bonjour

Vous avez rempli une demande de création de compte sur le Cahier de Prépa <https://$site>, correspondant à l'identifiant ${r['login']}.

Cette demande vient de recevoir une réponse favorable de la part de l'équipe pédagogique en charge du site. Vous pouvez donc désormais vous connecter avec votre identifiant et votre mot de passe.

Bonne navigation sur Cahier de Prépa.

Cordialement,
-- 
Cahier de Prépa
",'From: =?UTF-8?B?'.base64_encode('Cahier de Prépa')."?= <$mailadmin>\r\nContent-type: text/plain; charset=UTF-8","-f$mailadmin");
        exit($_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"Demande de compte $compte accordée. L'élève a été prévenu par courriel.\"}");
      }
      exit("{\"etat\":\"nok\",\"message\":\"La validation du compte $compte n'a pas été réalisée. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
    }
  }
}

//////////////////////////////////////////
// Modification multiple d'utilisateurs // 
//////////////////////////////////////////
elseif ( ( $action == 'utilisateurs' ) && isset($_REQUEST['modif']) && in_array($modif = $_REQUEST['modif'],array('mailenvoi','desactive','active','supprutilisateur','validutilisateur')) && isset($_REQUEST['ids']) && strlen($ids = implode(',',array_filter(explode(',',$_REQUEST['ids']),function($id) { return ctype_digit($id); }))) )  {

  // Vérification que les identifiants sont valides
  // Attention, les valeurs "valide", "demande" et "invitation" sont des chaines de caractères égales à '0' ou '1'.
  $resultat = $mysqli->query("SELECT id, nom, prenom, login, mail, (LENGTH(mdp)=40) AS valide, (LEFT(mdp,1)='*') AS demande, (LENGTH(mdp)=1) AS invitation, autorisation, mailenvoi, mailexp, mailliste, mailcopie FROM utilisateurs WHERE FIND_IN_SET(id,'$ids')");
  if ( !$resultat->num_rows )
    exit('{"etat":"nok","message":"Identifiants non valides"}');
  $message = array('ok'=>'','nok'=>'');
  switch ( $modif )  {

    // Modification de la possibilité d'envoyer des mails seulement
    case 'mailenvoi': {
      $val = intval( isset($_REQUEST['val']) && ( $_REQUEST['val'] == 1 ) );
      while ( $r = $resultat->fetch_assoc() )  {
        $compte = ( strlen($r['nom'].$r['prenom']) ) ? "de <em>${r['prenom']} ${r['nom']}</em>" : "<em>${r['login']}</em>";
        if ( ( $r['autorisation'] == 1 ) || ( $val == $r['mailenvoi'] ) || ( $val && !strlen($r['mail']) ) )
          $message['nok'] .= "Les préférences d'envoi de mail $compte n'ont pas été modifiées, car le compte ne peut envoyer de mail ou en envoie déjà.<br>";
        elseif ( requete('utilisateurs',"UPDATE utilisateurs SET mailenvoi = $val, mailexp = IF($val AND mailexp = '',CONCAT(prenom,' ',nom),mailexp) WHERE id = ${r['id']}",$mysqli) )
          $message['ok'] .= "Les préférences d'envoi de mail $compte ont été modifiées.<br>";
        else
          $message['nok'] .= "Les préférences d'envoi de mail $compte n'ont pas été modifiées. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»<br>';
      }
    }

    // Désactivation
    case 'desactive': {
      while ( $r = $resultat->fetch_assoc() )  {
        $compte = ( strlen($r['nom'].$r['prenom']) ) ? "de <em>${r['prenom']} ${r['nom']}</em>" : "<em>${r['login']}</em>";
        if ( ( $r['demande'] == 1 ) || ( $r['invitation'] == 1 ) || ( $r['valide'] == 0 ) )
          $message['nok'] .= "Le compte $compte n'a pas été désactivé, car il l'est déjà ou ne peut pas l'être.<br>";
        elseif ( requete('utilisateurs',"UPDATE utilisateurs SET mdp = CONCAT('!',mdp) WHERE id = ${r['id']}",$mysqli) )
          $message['ok'] .= "Le compte $compte a été désactivé.<br>";
        else
          $message['nok'] .= "Le compte $compte n'a pas été désactivé. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»<br>';
      }
    }

    // Réactivation
    case 'active': {
      while ( $r = $resultat->fetch_assoc() )  {
        $compte = ( strlen($r['nom'].$r['prenom']) ) ? "de <em>${r['prenom']} ${r['nom']}</em>" : "<em>${r['login']}</em>";
        if ( ( $r['demande'] == 1 ) || ( $r['invitation'] == 1 ) || ( $r['valide'] == 1 ) )
          $message['nok'] .= "Le compte $compte n'a pas été activé, car il l'est déjà ou ne peut pas l'être.<br>";
        elseif ( requete('utilisateurs',"UPDATE utilisateurs SET mdp = SUBSTR(mdp,2) WHERE id = ${r['id']}",$mysqli) )
          $message['ok'] .= "Le compte $compte a été réactivé.<br>";
        else
          $message['nok'] .= "Le compte $compte n'a pas été réactivé. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»<br>';
      }
    }

    // Suppression
    case 'supprutilisateur': {
      while ( $r = $resultat->fetch_assoc() )  {
        $compte = ( strlen($r['nom'].$r['prenom']) ) ? "de <em>${r['prenom']} ${r['nom']}</em>" : "<em>${r['login']}</em>";
        if ( requete('utilisateurs',"DELETE FROM utilisateurs WHERE id = ${r['id']}",$mysqli)
          && requete('groupes',"UPDATE groupes SET utilisateurs = TRIM(BOTH ',' FROM REPLACE(CONCAT(',',utilisateurs,','),',${r['id']},',',')) WHERE FIND_IN_SET(${r['id']},utilisateurs)",$mysqli) )  {
          // Recherche des notes : cas des colleurs/profs
          if ( $r['autorisation'] > 2 )  {
            requete('notes',"DELETE FROM notes WHERE colleur = $id",$mysqli);
            requete('heurescolles',"DELETE FROM heurescolles WHERE colleur = $id",$mysqli);
          }
          // Recherche des notes : cas des élèves
          elseif ( $r['autorisation'] == 2 )  {
            $resultat = $mysqli->query("SELECT GROUP_CONCAT(heure) FROM notes WHERE eleve = $id");
            $s = $resultat->fetch_row();
            $resultat->free();
            if ( !is_null($s[0]) )  {
              requete('notes',"DELETE FROM notes WHERE eleve = $id",$mysqli);
              requete('heurescolles',"DELETE heurescolles FROM heurescolles LEFT JOIN notes ON heurescolles.id=notes.heure
                                      WHERE FIND_IN_SET(heurescolles.id,'${s[0]}') AND notes.id IS NULL",$mysqli);
              requete('heurescolles',"UPDATE heurescolles SET duree = duree-(SELECT dureecolle FROM matieres WHERE matieres.id = heurescolles.matiere) 
                                      WHERE FIND_IN_SET(heurescolles.id,'${s[0]}') AND releve = 0",$mysqli);
            }
          }
          $message['ok'] .= "Le compte $compte a été supprimé.<br>";
        }
        else
          $message['nok'] .= "Le compte $compte n'a pas été supprimé. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»<br>';
      }
    }

    // Validation d'une demande
    case 'validutilisateur': {
      while ( $r = $resultat->fetch_assoc() )  {
        $compte = ( strlen($r['nom'].$r['prenom']) ) ? "de <em>${r['prenom']} ${r['nom']}</em>" : "<em>${r['login']}</em>";
        if ( $r['demande'] == 0 )
          $message['nok'] .= "La demande $compte a déjà été validée.<br>";
        elseif ( requete('utilisateurs',"UPDATE utilisateurs SET mdp = SUBSTR(mdp,2) WHERE id = ${r['id']}",$mysqli) )  {
          mail($r['mail'],'=?UTF-8?B?'.base64_encode('[Cahier de Prépa] Compte validé').'?=',
"Bonjour

Vous avez rempli une demande de création de compte sur le Cahier de Prépa <https://$site>, correspondant à l'identifiant ${r['login']}.

Cette demande vient de recevoir une réponse favorable de la part de l'équipe pédagogique en charge du site. Vous pouvez donc désormais vous connecter avec votre identifiant et votre mot de passe.

Bonne navigation sur Cahier de Prépa.

Cordialement,
-- 
Cahier de Prépa
",'From: =?UTF-8?B?'.base64_encode('Cahier de Prépa')."?= <$mailadmin>\r\nContent-type: text/plain; charset=UTF-8","-f$mailadmin");
          $message['ok'] .= "La demande de compte $compte a été accordée. L'élève a été prévenu par courriel.";
        }
        else
          $message['nok'] .= "La validation du compte $compte n'a pas été réalisée. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».<br>';
      }
    }

  }
  $resultat->free();
  if ( strlen($message['ok']) )
    exit($_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"${message['ok']}${message['nok']}\"}");
  exit("{\"etat\":\"nok\",\"message\":\"${message['nok']}\"}");
}

////////////////////////////////////
// Ajout de nouveaux utilisateurs //
////////////////////////////////////
elseif ( ( $action == 'ajout-utilisateurs' ) && isset($_REQUEST['listeutilisateurs']) && isset($_REQUEST['autorisation']) && in_array($autorisation = intval($_REQUEST['autorisation']),array(1,2,3,4,5)) && isset($_REQUEST['saisie']) && isset($_REQUEST['matieres']) && count($matieres = array_filter($_REQUEST['matieres'],function($id) { return ctype_digit($id); })) )  {
  
  // Vérification des matières -- on ne garde que les identifiants existants,
  // et on prend silencieusement par défaut l'ensemble des matières
  $resultat = $mysqli->query('SELECT GROUP_CONCAT(id) AS matieres FROM matieres');
  $r = $resultat->fetch_row();
  $resultat->free();
  $matieres = '0,'.implode(',', array_intersect($_REQUEST['matieres'],explode(',',$r[0])) ?: explode(',',$r[0]) );
  
  // Récupération des identifiants existants
  $resultat = $mysqli->query('SELECT GROUP_CONCAT(login) FROM utilisateurs');
  $r = $resultat->fetch_row();
  $resultat->free();
  $logins = explode(',',$r[0]);
  
   // Récupération des lignes
  $utilisateurs = explode("\n",$_REQUEST['listeutilisateurs']);
  
  // Compteurs : $n nb de comptes ajoutés; $i compteur de ligne traitée
  $n = $i = 0;
  $message = '';
  // Comptes invités : login,mdp
  if ( $autorisation == 1 )
    foreach ( $utilisateurs as $utilisateur)  {
      if ( !strlen(trim($utilisateur)) )
        continue;
      $u = array_map('trim',explode(',',$utilisateur));
      $i = $i+1;
      if ( ( count($u) != 2 ) || !strlen($u[0]) || !strlen($u[1]) )
        $message .= "<br>Ligne $i : mauvais paramètres";
      elseif ( in_array($login = mb_strtolower(str_replace(' ','_',$u[0])),$logins) )
        $message .= "<br>Ligne $i : identifiant <strong>$login</strong> déjà existant";
      elseif ( requete('utilisateurs',"INSERT INTO utilisateurs SET login = '$login', mdp = '".sha1($mdp.$u[1])."', autorisation = 1, matieres = '$matieres', timeout=900",$mysqli) )  {
        $message .= "<br>Ligne $i : ok (identifiant <strong>$login</strong>)";
        $n = $n+1;
      }
      else
        $message .= "<br>Ligne $i : erreur MySQL n°".$mysqli->errno.' «'.$mysqli->error.'»';
    }
  // Autres comptes : nom,prenom,mail ou nom,prenom,mdp
  else
    foreach ( $utilisateurs as $utilisateur)  {
      if ( !strlen(trim($utilisateur)) )
        continue;
      $u = array_map('trim',explode(',',$utilisateur));
      $i = $i+1;
      // Nettoyage des données envoyées
      if ( ( count($u) != 3 ) || !strlen($u[0].$u[1]) || !strlen($u[2]) )
        $message .= "<br>Ligne $i : mauvais paramètres";
      else  {
        $nom = mb_convert_case(strip_tags($mysqli->real_escape_string($u[0])),MB_CASE_TITLE);
        $prenom = mb_convert_case(strip_tags($mysqli->real_escape_string($u[1])),MB_CASE_TITLE);
        $login = mb_strtolower(mb_substr($prenom,0,1).str_replace(' ','_',$nom));
        if ( in_array($login,$logins) )
          $message .= "<br>Ligne $i : identifiant <strong>$login</strong> déjà existant";
        // Si nom,prenom,mdp
        elseif ( $_REQUEST['saisie'] == 2 )  {
          if ( requete('utilisateurs',"INSERT INTO utilisateurs SET login = '$login', prenom = '$prenom', nom = '$nom', mdp = '".sha1($mdp.$u[2])."', autorisation = $autorisation, matieres = '$matieres', timeout = 900",$mysqli) )  {
            $message .= "<br>Ligne $i : ok (<strong>$prenom $nom</strong>, identifiant $login)";
            $n = $n+1;
          }
          else
            $message .= "<br>Ligne $i : erreur MySQL n°".$mysqli->errno.' «'.$mysqli->error.'»';
        }
        // Si nom,prenom,mail
        else  {
          // Récupération des adresses électroniques
          $resultat = $mysqli->query('SELECT GROUP_CONCAT(mail) FROM utilisateurs WHERE mail > \'\'');
          $r = $resultat->fetch_row();
          $resultat->free();
          if ( in_array($mail = mb_strtolower($u[2]),explode(',',$r[0])) )
            $message .= "<br>Ligne $i : adresse électronique déjà existante (<strong>$prenom $nom</strong>)";
          elseif ( !filter_var($mail,FILTER_VALIDATE_EMAIL) )
            $message .= "<br>Ligne $i : adresse électronique non valide (<strong>$prenom $nom</strong>)";
          else  {
            $mailenvoi = intval(isset($_REQUEST['mailenvoi']));
            $mailexp = $mailenvoi ? "$prenom $nom" : '';
            $mailliste = ( $mailenvoi && ( $autorisation > 2 ) ) ? intval(isset($_REQUEST['mailliste'])) : 0;
            if ( requete('utilisateurs',"INSERT INTO utilisateurs SET login = '$login', prenom = '$prenom', nom = '$nom', mail = '$mail', mdp = '?', autorisation = $autorisation, matieres = '$matieres', timeout = 900, mailenvoi = $mailenvoi, mailcopie = $mailenvoi, mailexp = '$mailexp', mailliste = $mailliste",$mysqli) )  {
              $message .= "<br>Ligne $i : ok (<strong>$prenom $nom</strong>, identifiant $login)";
              $n = $n+1;
              $lien = 'https://'.$site.'/gestioncompte?invitation&mail='.str_replace('@','__',$mail).'&p='.sha1($site.$mdp.$mail);
              // Récupération de l'adresse électronique du professeur connecté
              $resultat = $mysqli->query("SELECT mail FROM utilisateurs WHERE id = ${_SESSION['id']}");
              $s = $resultat->fetch_row();
              $resultat->free();
              $returnpath = $s[0] ?: $mailadmin;
              mail($mail,'=?UTF-8?B?'.base64_encode('[Cahier de Prépa] Invitation').'?=',
"Bonjour

L'équipe pédagogique en charge du Cahier de Prépa <https://$site> vous invite à les rejoindre.

S'il s'agit d'une erreur, merci d'ignorer simplement ce courriel.

Sinon, veuillez cliquer ci-dessous pour vous rendre à la page qui vous permettra d'entrer un mot de passe :
   $lien

Si ce lien ne s'ouvre pas correctement, il a peut-être été coupé lors du clic : dans ce cas, essayez à nouveau en copiant-collant le lien.

Bonne navigation sur Cahier de Prépa.

Cordialement,
-- 
Cahier de Prépa
",'From: =?UTF-8?B?'.base64_encode('Cahier de Prépa')."?= <$mailadmin>\r\nContent-type: text/plain; charset=UTF-8","-f$returnpath");
            }
            else
              $message .= "<br>Ligne $i : erreur MySQL n°".$mysqli->errno.' «'.$mysqli->error.'»';
          }
        }
      }
    }
  // Fabrication du message
  $nouveaucompte = ( $n > 1 ) ? 'nouveaux comptes' : 'nouveau compte';
  if ( $e = $i-$n )
    exit("{\"etat\":\"nok\",\"message\":\"<strong>$n $nouveaucompte et $e erreur".($e>1?'s':'')."</strong>$message\"}");
  exit($_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"<strong>$n $nouveaucompte</strong>$message\"}");
}

///////////////////////////////////////////////////////////////
// Modification d'une association utilisateur-matière unique //
///////////////////////////////////////////////////////////////
elseif ( ( $action == 'utilisateur-matiere' ) && isset($_REQUEST['id']) && ctype_digit($id = $_REQUEST['id']) && isset($_REQUEST['matiere']) && ctype_digit($mid = $_REQUEST['matiere']) && isset($_REQUEST['val']) )  {

  // Vérification que l'identifiant de la matière est valide
  $resultat = $mysqli->query("SELECT nom FROM matieres WHERE id = $mid");
  if ( !$resultat->num_rows )
    exit('{"etat":"nok","message":"Identifiant de matière non valide"}');
  $r = $resultat->fetch_row();
  $resultat->free();
  $matiere = $r[0];
  
  // Vérification que l'identifiant de l'utilisateur est valide
  $resultat = $mysqli->query("SELECT IF(nom>'',CONCAT(prenom,' ',nom),CONCAT('<em>',login,'</em>')) AS nom, FIND_IN_SET('$mid',matieres)>0 AS matiere, LOCATE(',',matieres,3) AS multi FROM utilisateurs WHERE id = $id");
  if ( !$resultat->num_rows )
    exit('{"etat":"nok","message":"Identifiant d\'utilisateur non valide"}');
  $r = $resultat->fetch_assoc();
  $resultat->free();
  
  // Modification
  $val = intval( $_REQUEST['val'] > 0 );
  // Si rien à faire
  if ( $r['matiere'] == $val )
    exit('{"etat":"nok","message":"Ce réglage était déjà celui en place. Aucune modification n\'a été effectuée."}');
  // Si une seule matière à retirer : impossible
  if ( !$val && ( $r['multi'] == 0 ) )
    $message = "{\"etat\":\"nok\",\"message\":\"L'utilisateur ${r['nom']} n'est associé qu'à une seule matière. Il est impossible de supprimer cette association.\"}";
  // Association
  elseif ( $val && requete('utilisateurs',"UPDATE utilisateurs SET matieres = CONCAT(matieres,',$mid') WHERE id = $id",$mysqli) )
    $message = "{\"etat\":\"ok\",\"message\":\"L'utilisateur ${r['nom']} a été associé à la matière $matiere.\"}";
  // Désassociation
  elseif ( !$val && requete('utilisateurs',"UPDATE utilisateurs SET matieres = TRIM(TRAILING ',' FROM REPLACE(CONCAT(matieres,','),',$mid,',',')) WHERE id = $id",$mysqli) )
    $message = "{\"etat\":\"ok\",\"message\":\"L'association de l'utilisateur ${r['nom']} à la matière $matiere a été supprimée.\"}";
  else
    exit("{\"etat\":\"nok\",\"message\":\"L'association de l'utilisateur ${r['nom']} à la matière $matiere n'a pas été modifiée. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
  // Mise à jour de $_SESSION['matieres'] si besoin
  if ( $id == $_SESSION['id'] )  {
    $resultat = $mysqli->query("SELECT matieres FROM utilisateurs WHERE id = $id");
    $r = $resultat->fetch_row();
    $resultat->free();
    $_SESSION['matieres'] = $r[0];
  }
  exit($message);

}

////////////////////////////////////////////////////////////////
// Modification multiple d'associations utilisateurs-matières //
////////////////////////////////////////////////////////////////
elseif ( ( $action == 'utilisateurs-matieres' ) && isset($_REQUEST['ids']) && strlen($ids = implode(',',array_filter(explode(',',$_REQUEST['ids']),function($id) { return ctype_digit($id); }))) && isset($_REQUEST['matiere']) && ctype_digit($mid = $_REQUEST['matiere']) && isset($_REQUEST['val']) )  {

  // Vérification que l'identifiant de la matière est valide
  $resultat = $mysqli->query("SELECT nom FROM matieres WHERE id = $mid");
  if ( !$resultat->num_rows )
    exit('{"etat":"nok","message":"Identifiant de matière non valide"}');
  $r = $resultat->fetch_row();
  $resultat->free();
  $matiere = $r[0];
  
  // Vérification que les identifiants d'utilisateur sont valides
  $resultat = $mysqli->query("SELECT id, nom, prenom, login, FIND_IN_SET('$mid',matieres)>0 AS matiere, LOCATE(',',matieres,3) AS multi FROM utilisateurs WHERE FIND_IN_SET(id,'$ids')");
  if ( !$resultat->num_rows )
    exit('{"etat":"nok","message":"Identifiants d\'utilisateur non valides"}');  
  $message = array('ok'=>'','nok'=>'');
    
  // Modification
  $val = intval( $_REQUEST['val'] > 0 );
  while ( $r = $resultat->fetch_assoc() )  {
    $compte = ( strlen($r['nom'].$r['prenom']) ) ? "de <em>${r['prenom']} ${r['nom']}</em>" : "<em>${r['login']}</em>";
    // Si rien à faire
    if ( $r['matiere'] == $val )
      $message['nok'] .= "Le compte $compte n'a pas été modifié, car son association à la matière <em>$matiere</em> est déjà celle demandée.<br>";
    // Si une seule matière à retirer : impossible
    elseif ( !$val && ( $r['multi'] == 0 ) )
      $message['nok'] .= "Le compte $compte n'est associé qu'à une seule matière. Il est impossible de supprimer cette association.<br>";
    // Association
    elseif ( $val && requete('utilisateurs',"UPDATE utilisateurs SET matieres = CONCAT(matieres,',$mid') WHERE id = ${r['id']}",$mysqli) )
      $message['ok'] .= "Le compte $compte a été associé à la matière <em>$matiere</em>.<br>";
    // Désassociation
    elseif ( !$val && requete('utilisateurs',"UPDATE utilisateurs SET matieres = TRIM(TRAILING ',' FROM REPLACE(CONCAT(matieres,','),',$mid,',',')) WHERE id = ${r['id']}",$mysqli) )
      $message['ok'] .= "L'association du compte $compte à la matière <em>$matiere</em> a été supprimée.<br>";
    else
      $message['nok'] .= "L'association de l'utilisateur ${r['nom']} à la matière $matiere n'a pas été modifiée. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».<br>';
    // Mise à jour de $_SESSION['matieres'] si besoin
    if ( $r['id'] == $_SESSION['id'] )  {
      $res = $mysqli->query("SELECT matieres FROM utilisateurs WHERE id = ${r['id']}");
      $r = $res->fetch_row();
      $res->free();
      $_SESSION['matieres'] = $r[0];
    }
  }
  $resultat->free();
  if ( strlen($message['ok']) )
    exit($_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"${message['ok']}${message['nok']}\"}");
  exit("{\"etat\":\"nok\",\"message\":\"${message['nok']}\"}");
}

/////////////////////////////////////////////
// Modification des groupes d'utilisateurs //
/////////////////////////////////////////////
elseif ( ( $action == 'groupes' ) && isset($_REQUEST['id']) && ctype_digit($id = $_REQUEST['id']) )  {

  // Vérification que l'identifiant est valide
  $resultat = $mysqli->query("SELECT nom, mails, notes, utilisateurs FROM groupes WHERE id = $id");
  if ( !$resultat->num_rows )
    exit('{"etat":"nok","message":"Identifiant non valide"}');
  $r = $resultat->fetch_assoc();
  $resultat->free();

  // Suppression
  if ( isset($_REQUEST['supprime']) )  {
    if ( requete('groupes',"DELETE FROM groupes WHERE id = $id",$mysqli) ) 
      exit("{\"etat\":\"ok\",\"message\":\"Le groupe ${r['nom']} a été supprimé.\"}");
    exit("{\"etat\":\"nok\",\"message\":\"Le groupe ${r['nom']} n'a pas été supprimé. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
  }

  // Modification
  if ( isset($_REQUEST['champ']) )  {
    switch ( $champ = $_REQUEST['champ'] )  {
      case 'nom':
        if ( !strlen($val = trim($mysqli->real_escape_string($_REQUEST['val']))) )
          exit("{\"etat\":\"nok\",\"message\":\"Le nom du groupe ${r['nom']} n'a pas été modifié&nbsp;: le nom ne peut pas être vide.\"}");
        if ( requete('groupes',"UPDATE groupes SET nom = '$val', nom_nat = '".zpad($val)."' WHERE id = $id",$mysqli) )  {
          $mysqli->query('ALTER TABLE groupes ORDER BY nom_nat');
          exit("{\"etat\":\"ok\",\"message\":\"Le nom du groupe ${r['nom']} a été modifié.\"}");
        }
        exit("{\"etat\":\"nok\",\"message\":\"Le nom du groupe ${r['nom']} n'a pas été modifié. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
      case 'mails':
      case 'notes':
        $val = intval( $_REQUEST['val'] > 0 );
        if ( requete('groupes',"UPDATE groupes SET $champ = $val WHERE id = $id",$mysqli) )
          exit("{\"etat\":\"ok\",\"message\":\"Le groupe ${r['nom']} a été modifié.\"}");
        exit("{\"etat\":\"nok\",\"message\":\"Le groupe ${r['nom']} n'a pas été modifié. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
      case 'utilisateurs':
        if ( !isset($_REQUEST['uids']) || !strlen($ids = implode(',',array_filter(explode(',',$_REQUEST['uids']),function($id) { return ctype_digit($id); }))) )
          exit("{\"etat\":\"nok\",\"message\":\"La composition du groupe ${r['nom']} n'a pas été modifiée&nbsp;: le groupe ne peut pas être vide.\"}");
        // Vérification des identifiants d'utilisateurs - tous utilisateurs autorisés
        $resultat = $mysqli->query("SELECT GROUP_CONCAT(id) FROM utilisateurs WHERE FIND_IN_SET(id,'$ids')");
        $s = $resultat->fetch_row();
        $resultat->free();
        if ( !$s[0] )
          exit("{\"etat\":\"nok\",\"message\":\"La composition du groupe ${r['nom']} n'a pas été modifiée&nbsp;: le groupe ne peut pas être vide.\"}");
        if ( requete('groupes',"UPDATE groupes SET utilisateurs = '${s[0]}' WHERE id = $id",$mysqli) )
          exit("{\"etat\":\"ok\",\"message\":\"La composition du groupe ${r['nom']} a été modifié.\"}");
        exit("{\"etat\":\"nok\",\"message\":\"La composition du groupe ${r['nom']} n'a pas été modifié. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
    }
  }
  exit('{"etat":"nok","message":"Champ non valide"}');
}

//////////////////////////////////////
// Ajout d'un groupe d'utilisateurs //
//////////////////////////////////////
elseif ( ( $action == 'ajout-groupe' ) && isset($_REQUEST['nom']) && strlen($nom = trim($mysqli->real_escape_string($_REQUEST['nom']))) && isset($_REQUEST['uids']) && strlen($ids = implode(',',array_filter(explode(',',$_REQUEST['uids']),function($id) { return ctype_digit($id); })))  )  {

  // Vérification des identifiants d'utilisateurs - tous utilisateurs autorisés
  $resultat = $mysqli->query("SELECT GROUP_CONCAT(id) FROM utilisateurs WHERE FIND_IN_SET(id,'$ids')");
  $r = $resultat->fetch_row();
  $resultat->free();
  if ( !$r[0] )
    exit('{"etat":"nok","message":"Un groupe ne peut pas être vide."}');
  // Champs mails et notes
  $mails = intval(isset($_REQUEST['mails']));
  $notes = intval(isset($_REQUEST['notes']));
  // Écriture
  if ( requete('groupes',"INSERT INTO groupes SET nom = '$nom', nom_nat = '".zpad($nom)."', mails = $mails, notes = $notes, utilisateurs = '${r[0]}'",$mysqli) )  {
    $mysqli->query('ALTER TABLE groupes ORDER BY nom_nat');
    exit($_SESSION['message'] = '{"etat":"ok","message":"Le groupe a été ajouté."}');
  }
  exit('{"etat":"nok","message":"Le groupe n\'a pas été ajouté. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
}

//////////////////////////////
// Modification du planning //
//////////////////////////////
elseif ( $action == 'planning' )  {

  // Récupérations des donnees envoyées
  $colles = ( isset($_REQUEST['colles']) ) ? $_REQUEST['colles'] : array();
  $vacances = ( isset($_REQUEST['vacances']) ) ? $_REQUEST['vacances'] : array();
  // Comparaison et modification
  $modif = array();
  $resultat = $mysqli->query('SELECT id, colle, vacances, DATE_FORMAT(debut,\'%d/%m/%Y\') AS debut FROM semaines');
  while ( $r = $resultat->fetch_assoc() )  {
    $v = intval( ( ctype_digit($v = $vacances[$r['id']]) && ( $v < 5 ) ) ? $v : 0 );
    $c = intval( isset($colles[$r['id']]) && !$v );
    if ( ( $c != $r['colle'] ) || ( $v != $r['vacances'] ) )  {
      requete('semaines',"UPDATE semaines SET colle = $c, vacances = $v WHERE id = ${r['id']}",$mysqli);
      $modif[] = "semaine du ${r['debut']}";
    }
  }
  // Message à afficher
  exit( $modif ? '{"etat":"ok","message":"Les modifications ont été réalisées ('.implode(', ',$modif).')."}' : '{"etat":"ok","message":"Aucune modification n\'a été réalisée."}');
}

//////////////////////////////
// Modification de l'agenda //
//////////////////////////////
elseif ( $action == 'agenda-elems' )  {
  
  // Traitement d'une suppression
  if ( isset($_REQUEST['supprime']) && isset($_REQUEST['id']) && ctype_digit($id = $_REQUEST['id']) )  {
    $resultat = $mysqli->query("SELECT matiere FROM agenda WHERE id = $id");
    if ( !$resultat->num_rows )
      exit('{"etat":"nok","message":"Identifiant non valide"}');
    $r = $resultat->fetch_row();
    $resultat->free();
    if ( requete('agenda',"DELETE FROM agenda WHERE id = $id",$mysqli) )  {
      recent($mysqli,5,$id,$r[0]);
      exit($_SESSION['message'] = '{"etat":"ok","message":"La suppression a été réalisée."}');
    }
    exit('{"etat":"nok","message":"L\'événement n\'a pas été supprimé. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
  }

  // Traitement d'une modification/d'un ajout d'événement :
  // validation préliminaire
  if ( isset($_REQUEST['type']) && isset($_REQUEST['matiere']) && isset($_REQUEST['debut']) && isset($_REQUEST['fin']) && ctype_digit($tid = $_REQUEST['type']) && ctype_digit($mid = $_REQUEST['matiere']) )  {
    // Validation des dates
    $debut = $_REQUEST['debut'];
    if ( strlen($debut) == 10 )
      $debut .= ' 00h00';
    elseif ( strlen($debut) == 15 )
      $debut = substr($debut,0,11).'0'.substr($debut,11);
    $fin = $_REQUEST['fin'];
    if ( strlen($fin) == 10 )
      $fin .= ' 00h00';
    elseif ( strlen($fin) == 15 )
      $fin = substr($fin,0,11).'0'.substr($fin,11);
    $debut = preg_filter('/(\d{2})\/(\d{2})\/(\d{4}) (\d{1,2})h(\d{2})/','$3-$2-$1 $4:$5',$debut);
    $fin = preg_filter('/(\d{2})\/(\d{2})\/(\d{4}) (\d{1,2})h(\d{2})/','$3-$2-$1 $4:$5',$fin);
    if ( is_null($debut) || is_null($fin) || ( $debut > $fin ) )
      exit('{"etat":"nok","message":"Les dates/heures choisies ne sont pas valables."}');
    // Validation des dates : l'événement doit se trouver en partie dans
    // l'année scolaire
    $resultat = $mysqli->query("SELECT id FROM semaines WHERE debut <= '$fin' AND debut >= SUBDATE('$debut',80) LIMIT 1");
    if ( !$resultat->num_rows )
      exit('{"etat":"nok","message":"Les dates de l\'événement le placent hors de l\'année scolaire."}');
    $resultat->free();
    // Pour les informations récentes : jour et mois
    $jour = substr($debut,8,2);
    $mois = substr($debut,5,2);
    $annee = substr($debut,2,2);
    // Validation du type d'événement
    $resultat = $mysqli->query("SELECT nom FROM `agenda-types` WHERE id = $tid");
    if ( !$resultat->num_rows )
      exit('{"etat":"nok","message":"Type d\'événement non valide."}');
    // Besoin du nom pour les informations récentes
    $r = $resultat->fetch_row();
    $resultat->free();
    $type = $r[0];
    if ( $mid )  {
      // Validation de la matière si non nulle
      $resultat = $mysqli->query("SELECT nom FROM matieres WHERE id = $mid");
      if ( !$resultat->num_rows )
        exit('{"etat":"nok","message":"Matière non valide."}');
      // Besoin du nom pour les informations récentes
      $r = $resultat->fetch_row();
      $resultat->free();
      $matiere = $r[0];
    }
    else
      $matiere = '';
    // Validation du texte
    $texte = $mysqli->real_escape_string($_REQUEST['texte']);
    // Vérification que l'identifiant est valide
    if ( isset($_REQUEST['id']) && ctype_digit($id = $_REQUEST['id']) )  {
      $resultat = $mysqli->query("SELECT id FROM agenda WHERE id = $id");
      if ( !$resultat->num_rows ) 
        exit('{"etat":"nok","message":"Identifiant non valide"}');
      $resultat->free();
      // Écriture dans la base de données
      if ( requete('agenda',"UPDATE agenda SET matiere = $mid, type = $tid, debut = '$debut', fin = '$fin', texte = '$texte' WHERE id = $id", $mysqli) )  {
        recent($mysqli,5,$id,$mid,array('titre'=>"$jour/$mois - $type ".( strlen($matiere) ? $mysqli->real_escape_string("en $matiere ") : '').'(mise à jour)', 'lien'=>"agenda?mois=$annee$mois", 'texte'=>$texte, 'matiere'=>$mid, 'protection'=>0));
        $mysqli->query('ALTER TABLE agenda ORDER BY fin, debut');
        exit($_SESSION['message'] = '{"etat":"ok","message":"L\'événement a été modifié."}');
      }
      exit('{"etat":"nok","message":"L\'événement n\'a pas été modifié. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
    }

    // Nouvel événement
    if ( requete('agenda',"INSERT INTO agenda SET matiere = $mid, type = $tid, debut = '$debut', fin = '$fin', texte = '$texte'", $mysqli) )  {
      recent($mysqli,5,$mysqli->insert_id,$mid,array('titre'=>"$jour/$mois - $type ".( strlen($matiere) ? $mysqli->real_escape_string("en $matiere ") : ''), 'lien'=>"agenda?mois=$annee$mois", 'texte'=>$texte, 'matiere'=>$mid, 'protection'=>0));
      $mysqli->query('ALTER TABLE agenda ORDER BY fin, debut');
      exit($_SESSION['message'] = '{"etat":"ok","message":"L\'événement a été ajouté."}');
    }
    exit('{"etat":"nok","message":"L\'événement n\'a pas été ajouté. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
  }
}

//////////////////////////////////////////////////////////////
// Modification de l'agenda : cas des déplacements de colle //
//////////////////////////////////////////////////////////////
elseif ( $action == 'deplcolle' )  {
  
  // On ne réalise ici que des ajouts d'événements. Pas de suppression, pas de
  // modification. Événements simultanés si deux dates renseignées.

  // Validation préliminaire
  if ( !isset($_REQUEST['matiere']) || !isset($_REQUEST['colleur']) || !isset($_REQUEST['groupe']) || !ctype_digit($matiere = $_REQUEST['matiere']) || !strlen($colleur = $_REQUEST['colleur']) || !strlen($groupe = $_REQUEST['groupe']) )
    exit('{"etat":"nok","message":"La matière, le colleur et le groupe sont obligatoires."}');

  // Validation des dates
  $mois = array('','janvier','février','mars','avril','mai','juin','juillet','août','septembre','octobre','novembre','décembre');
  switch ( strlen($_REQUEST['ancien']) )  {
    case 0: $ancien_sql = ''; break;
    case 10:
      $ancien_sql = preg_filter('/(\d{2})\/(\d{2})\/(\d{4})/','$3-$2-$1',$_REQUEST['ancien'].' 00:00');
      $ancien = substr($ancien_sql,8,2);
      $ancien = (( $ancien == '01' ) ? '1er' : ltrim($ancien,'0')).' '.$mois[(int)substr($ancien_sql,5,2)];
      break;
    case 15: 
    case 16:
      $ancien_sql = preg_filter('/^(\d{2})\/(\d{2})\/(\d{4}) (\d{1,2})h(\d{2})$/','$3-$2-$1 $4:$5',$_REQUEST['ancien']);
      $ancien = substr($ancien_sql,8,2);
      $ancien = (( $ancien == '01' ) ? '1er' : ltrim($ancien,'0')).' '.$mois[(int)substr($ancien_sql,5,2)].' à'.str_replace(':','h',strstr($ancien_sql,' '));
      break;
    default: $ancien_sql = null;
  }
  switch ( strlen($_REQUEST['nouveau']) )  {
    case 0: $nouveau_sql = ''; break;
    case 10:
      $nouveau_sql = preg_filter('/(\d{2})\/(\d{2})\/(\d{4})/','$3-$2-$1',$_REQUEST['nouveau'].' 00:00');
      $nouveau = substr($nouveau_sql,8,2);
      $nouveau = (( $nouveau == '01' ) ? '1er' : ltrim($nouveau,'0')).' '.$mois[(int)substr($nouveau_sql,5,2)];
      break;
    case 15: 
    case 16:
      $nouveau_sql = preg_filter('/^(\d{2})\/(\d{2})\/(\d{4}) (\d{1,2})h(\d{2})$/','$3-$2-$1 $4:$5',$_REQUEST['nouveau']);
      $nouveau = substr($nouveau_sql,8,2);
      $nouveau = (( $nouveau == '01' ) ? '1er' : ltrim($nouveau,'0')).' '.$mois[(int)substr($nouveau_sql,5,2)].' à'.str_replace(':','h',strstr($nouveau_sql,' '));
      break;
    default: $nouveau_sql = null;
  }
  if ( is_null($ancien_sql) || is_null($nouveau_sql) )
    exit('{"etat":"nok","message":"Les dates/heures choisies ne sont pas valables."}');

  // Validation de la matière
  $resultat = $mysqli->query("SELECT nom FROM matieres WHERE id = $matiere");
  if ( !$resultat->num_rows )
    exit('{"etat":"nok","message":"Matière non valide."}');
    $r = $resultat->fetch_row();
  $resultat->free();
  // Début du texte des événements
  $texte = 'La colle du groupe '.$mysqli->real_escape_string("$groupe en {$r[0]} avec $colleur");
  // Seulement ancien horaire : annulation de colle
  if ( strlen($ancien_sql) && !strlen($nouveau_sql) )  {
    $validation = " '$ancien_sql' BETWEEN debut AND ADDDATE(debut,60)";
    $texte .= " prévue le $ancien est annulée.";
    $insertion = "($matiere,1,'$ancien_sql','$ancien_sql','<p>$texte</p>')";
  }
  // Seulement nouvel horaire : rattrapage de colle
  elseif ( !strlen($ancien_sql) && strlen($nouveau_sql) )  {
    $validation = " '$nouveau_sql' BETWEEN debut AND ADDDATE(debut,80)";
    $texte .= " est rattrapée le $nouveau".(( strlen($_REQUEST['salle']) ) ? ' en salle '.$mysqli->real_escape_string($_REQUEST['salle']) : '').'.';
    $insertion = "($matiere,2,'$nouveau_sql','$nouveau_sql','<p>$texte</p>')";
  }
  // Ancien et nouvel horaires : déplacement de colle
  else  {
    $validation = " '$ancien_sql' BETWEEN debut AND ADDDATE(debut,80) AND '$nouveau_sql' BETWEEN debut AND ADDDATE(debut,80)";
    $texte .= " est déplacée du $ancien au $nouveau".(( strlen($_REQUEST['salle']) ) ? ' en salle '.$mysqli->real_escape_string($_REQUEST['salle']) : '').'.';
    $insertion = "($matiere,1,'$ancien_sql','$ancien_sql','<p>$texte</p>'),($matiere,2,'$nouveau_sql','$nouveau_sql','<p>$texte</p>')";
  }
  // Validation des dates : chaque horaire doit se trouver dans l'année scolaire
  $resultat = $mysqli->query("SELECT id FROM semaines WHERE $validation LIMIT 1");
  if ( !$resultat->num_rows )
    exit('{"etat":"nok","message":"Le(s) horaire(s) fourni(s) se trouve(nt) hors de l\'année scolaire."}');
  $resultat->free();
  if ( requete('agenda',"INSERT INTO agenda (matiere,type,debut,fin,texte) VALUES $insertion", $mysqli) )  {
    $mysqli->query('ALTER TABLE agenda ORDER BY fin, debut');
    $debut = ( strlen($ancien_sql) ) ? $ancien_sql : $nouveau_sql;
    recent($mysqli,5,$mysqli->insert_id,$matiere,array('titre'=>substr($debut,8,2).'/'.substr($debut,5,2)." - Déplacement de colle en ".$mysqli->real_escape_string("${r[0]}, groupe $groupe"), 'lien'=>'agenda?mois='.substr($debut,2,2).substr($debut,5,2), 'texte'=>$texte, 'matiere'=>$matiere, 'protection'=>0));
    exit($_SESSION['message'] = '{"etat":"ok","message":"Déplacement de colle ajouté"}');
  }
  else
    exit('{"etat":"nok","message":"Le déplacement de colle n\'a pas été ajouté. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
}

/////////////////////////////////////////////////////
// Modification des types d'événements de l'agenda //
/////////////////////////////////////////////////////
elseif ( ( $action == 'agenda-types' ) && isset($_REQUEST['id']) && ctype_digit($id = $_REQUEST['id']) )  {

  // Vérification que l'identifiant est valide
  $resultat = $mysqli->query("SELECT ordre, nom, cle, couleur, (SELECT COUNT(*) FROM `agenda-types`) AS max FROM `agenda-types` WHERE id = $id");
  if ( !$resultat->num_rows )
    exit('{"etat":"nok","message":"Identifiant non valide"}');
  $r = $resultat->fetch_assoc();
  $resultat->free();

  // Traitement d'une modification
  if ( isset($_REQUEST['nom']) && isset($_REQUEST['cle']) && isset($_REQUEST['couleur']) )  {
    $nom = ucfirst($mysqli->real_escape_string($_REQUEST['nom']));
    $cle = str_replace(' ','_',trim($mysqli->real_escape_string($_REQUEST['cle'])));
    $couleur =  preg_filter('/^([0-9a-fA-F]{3}|[0-9a-fA-F]{6})$/','$1',$_REQUEST['couleur']);
    if ( !strlen($nom) || !strlen($cle) || !$couleur )
      exit('{"etat":"nok","message":"Le type d\'événements n\'a pas été modifié. Le nom, la clé et la couleur doivent être non vides."}');
    if ( $cle != $r['cle'] )  {
      // Vérification que la clé n'existe pas déjà
      $resultat = $mysqli->query("SELECT cle FROM `agenda-types` WHERE id != $id");
      if ( $resultat->num_rows )  {
        while ( $r = $resultat->fetch_assoc() )
          if ( $r['cle'] == $cle )
            exit('{"etat":"nok","message":"Le type d\'événements n\'a pas été modifié. Cette clé existe déjà et doit être unique."}');
        $resultat->free();
      }
    }
    if ( requete('agenda-types',"UPDATE `agenda-types` SET nom = '$nom', cle = '$cle', couleur = '$couleur' WHERE id = $id",$mysqli) )
      exit($_SESSION['message'] = '{"etat":"ok","message":"Le type d\'événements a été modifié."}');
    exit('{"etat":"nok","message":"Le type d\'événements n\'a pas été modifié. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
  }
  
  // Déplacement vers le haut
  if ( isset($_REQUEST['monte']) && ( $r['ordre'] > 1 ) )
    exit( ( requete('agenda-types',"UPDATE `agenda-types` SET ordre = (2*${r['ordre']}-1-ordre) WHERE ( ordre = ${r['ordre']} OR ordre = (${r['ordre']}-1) )",$mysqli)
            && $mysqli->query('ALTER TABLE `agenda-types` ORDER BY ordre') )
        ? '{"etat":"ok","message":"Le type d\'événements a été déplacé."}' : '{"etat":"nok","message":"Le type d\'événements n\'a pas été déplacé. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');

  // Déplacement vers le bas
  if ( isset($_REQUEST['descend']) && ( $r['ordre'] < $r['max'] ) )
    exit( ( requete('agenda-types',"UPDATE `agenda-types` SET ordre = (2*${r['ordre']}+1-ordre) WHERE ( ordre = ${r['ordre']} OR ordre = (${r['ordre']}+1) )",$mysqli)
            && $mysqli->query('ALTER TABLE `agenda-types` ORDER BY ordre') )
        ? '{"etat":"ok","message":"Le type d\'événements a été déplacé."}' : '{"etat":"nok","message":"Le type d\'événements n\'a pas été déplacé. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');

  // Suppression
  if ( isset($_REQUEST['supprime']) )
    exit( ( requete('agenda',"DELETE FROM agenda WHERE type = $id",$mysqli)
            && requete('agenda-types',"DELETE FROM `agenda-types` WHERE id = $id",$mysqli) 
            && requete('agenda-types',"UPDATE `agenda-types` SET ordre = (ordre-1) WHERE ordre > ${r['ordre']}",$mysqli) )
        ? '{"etat":"ok","message":"La suppression a été réalisée."}' : '{"etat":"nok","message":"Le type d\'événements n\'a pas été supprimé. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
}
  
//////////////////////////////////////////////
// Ajout d'un type d'événements de l'agenda //
//////////////////////////////////////////////
elseif ( ( $action == 'ajout-agenda-types' ) && isset($_REQUEST['nom']) && isset($_REQUEST['cle']) && isset($_REQUEST['couleur']) )  {
  $nom = ucfirst($mysqli->real_escape_string($_REQUEST['nom']));
  $cle = str_replace(' ','_',trim($mysqli->real_escape_string($_REQUEST['cle'])));
  $couleur =  preg_filter('/^([0-9a-fA-F]{3}|[0-9a-fA-F]{6})$/','$1',$_REQUEST['couleur']);
  if ( !strlen($nom) || !strlen($cle) || !$couleur )
    exit('{"etat":"nok","message":"Le type d\'événements n\'a pas été ajouté. Le nom, la clé et la couleur doivent être non vides."}');
  // Vérification que la clé n'existe pas déjà
  $resultat = $mysqli->query('SELECT cle FROM `agenda-types`');
  if ( $resultat->num_rows )  {
    while ( $r = $resultat->fetch_assoc() )
      if ( $r['cle'] == $cle )
        exit('{"etat":"nok","message":"Le type d\'événements n\'a pas été ajouté. Cette clé existe déjà et doit être unique."}');
    $resultat->free();
  }
  if ( requete('agenda-types',"INSERT INTO `agenda-types` SET nom = '$nom', cle = '$cle', couleur = '$couleur',
                               ordre = (SELECT max(t.ordre)+1 FROM `agenda-types` AS t)",$mysqli) )
    exit($_SESSION['message'] = '{"etat":"ok","message":"Le type d\'événements a été ajouté."}');
  exit('{"etat":"nok","message":"Le type d\'événements n\'a pas été ajouté. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
}

///////////////////////////////
// Modification des matières //
///////////////////////////////
elseif ( ( $action == 'prefsmatiere' ) && isset($_REQUEST['id']) && in_array($id = intval($_REQUEST['id']),explode(',',$_SESSION['matieres'])) )  {
  
  $resultat = $mysqli->query("SELECT nom, colles_protection, cdt_protection, docs_protection, dureecolle FROM matieres WHERE id = $id");
  $r = $resultat->fetch_assoc();
  $resultat->free();
  
  // Gestion de la durée de colle
  if ( isset($_REQUEST['dureecolle']) && ctype_digit($dureecolle = $_REQUEST['dureecolle']) )  {
    if ( requete('matieres',"UPDATE matieres SET dureecolle = $dureecolle WHERE id = $id",$mysqli) )
      exit($_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"La durée de colle par élève en <em>${r['nom']}</em> a été modifiée.\"}");
    exit("{\"etat\":\"nok\",\"message\":\"La durée de colle par élève en <em>${r['nom']}</em> n'a pas été modifiée. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
  }

  // Génération des valeurs de protection
  foreach ( array('colles','cdt','docs') as $fonction )  {
    if ( isset($_REQUEST[$fonction.'_protection']) )  {
      $val = array_filter($_REQUEST[$fonction.'_protection'],function($id) { return ctype_digit($id); });
      if ( !count($val) )
        exit("{\"etat\":\"nok\",\"message\":\"La matière <em>${r['nom']}</em> n'a pas été modifiée. La protection d'accès est incorrecte.\"}");
      if ( ( $val[0] == 0 ) || ( $val[0] == 32 ) )
        $protection = $val[0];
      else  {
        $protection = 32;
        foreach (array_slice($val,1) as $v) 
          $protection = $protection-2**($v-1);
      }
      if ( $protection == $r[$fonction.'_protection'] )
        exit('{"etat":"nok","message":"Aucune action effectuée : la protection saisie est la même que celle déjà en place."}');
      if ( requete('matieres',"UPDATE matieres SET ${fonction}_protection = $protection WHERE id = $id",$mysqli) )  {
        if ( $fonction == 'docs' )
          requete('reps',"UPDATE reps SET protection = $protection WHERE matiere = $id AND parent = 0",$mysqli);
        exit($_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"La matière <em>${r['nom']}</em> a été modifiée.\"}");
      }
      exit("{\"etat\":\"nok\",\"message\":\"La matière <em>${r['nom']}</em> n'a pas été modifiée. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');        
    }
  }
}
  
///////////////////////////////////////////
// Modification des préférences globales //
///////////////////////////////////////////
elseif ( $action == 'prefsglobales' )  {

  // Préférences de l'agenda : protection globale et nombre d'événements sur 
  // la page d'accueil
  if ( isset($_REQUEST['protection_agenda']) && isset($_REQUEST['nb_agenda_index']) && count( $val = array_filter($_REQUEST['protection_agenda'],function($id) { return ctype_digit($id); }) ) && ctype_digit($nb_agenda_index = $_REQUEST['nb_agenda_index']) )  {
    if ( ( $val[0] == 0 ) || ( $val[0] == 32 ) )
      $protection = $val[0];
    else  {
      $protection = 32;
      foreach (array_slice($val,1) as $v) 
        $protection = $protection-2**($v-1);
    }
    if ( requete('prefs',"UPDATE prefs SET val = $protection WHERE nom='protection_agenda'",$mysqli) && requete('prefs',"UPDATE prefs SET val = $nb_agenda_index WHERE nom='nb_agenda_index'",$mysqli) )
      exit($_SESSION['message'] = '{"etat":"ok","message":"Les préférences de l\'agenda ont été modifiées."}');
    exit('{"etat":"nok","message":"Les préférences globales de l\'agenda n\'ont pas été modifiées. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
  }
  
  // Préférence de création de compte, venant de utilisateurs.php
  if ( isset($_REQUEST['creation_compte']) )  {
    if ( requete('prefs','UPDATE prefs SET val = '.intval(isset($_REQUEST['autoriser'])).' WHERE nom="creation_compte"',$mysqli) )
      exit($_SESSION['message'] = '{"etat":"ok","message":"Les préférences de l\'agenda ont été modifiées."}');
    exit('{"etat":"nok","message":"Les préférences globales de l\'agenda n\'ont pas été modifiées. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
  }
}

// Sans action
exit('{"etat":"nok","message":"Aucune action effectuée"}');
?>
